/*
 * Generator/myKeyPairGenerator.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package Generator;
import java.io.FileOutputStream;
import java.io.ObjectOutputStream;
import java.security.KeyPair;
import java.security.KeyPairGenerator;

public class myKeyPairGenerator {
    public static void main(String[] argv) {
	try {
	    KeyPairGenerator keyPairGenerator = KeyPairGenerator.getInstance(argv[0]);
	    System.out.println("initialize KeyPairGenerator.");
	    keyPairGenerator.initialize(1024);
	    System.out.println("generate KeyPair.");
	    KeyPair ownKeyPair = keyPairGenerator.generateKeyPair();

	    System.out.println("public key:\n"+ownKeyPair.getPublic().toString());
	    System.out.println("\nprivate key:\n"+ownKeyPair.getPrivate().toString());

	    FileOutputStream fileOutputStream = new FileOutputStream(argv[0]+"publicKey.der");
	    System.out.println("writing public key to File: "+argv[0]+"publicKey.der");
	    fileOutputStream.write(ownKeyPair.getPublic().getEncoded());
	    fileOutputStream.close();

	    fileOutputStream = new FileOutputStream(argv[0]+"publicKey.object");
	    System.out.println("writing private key to File: "+argv[0]+"publicKey.object");
	    ObjectOutputStream objectOutputStream = new ObjectOutputStream(fileOutputStream);
	    objectOutputStream.writeObject(ownKeyPair.getPublic());
	    fileOutputStream.close();
	    objectOutputStream.close();

	    fileOutputStream = new FileOutputStream(argv[0]+"privateKey.der");
	    System.out.println("writing private key to File: "+argv[0]+"privateKey.der");
	    fileOutputStream.write(ownKeyPair.getPrivate().getEncoded());
	    fileOutputStream.close();

	    fileOutputStream = new FileOutputStream(argv[0]+"privateKey.object");
	    System.out.println("writing private key to File: "+argv[0]+"privateKey.object");
	    objectOutputStream = new ObjectOutputStream(fileOutputStream);
	    objectOutputStream.writeObject(ownKeyPair.getPrivate());
	    fileOutputStream.close();
	    objectOutputStream.close();
	}
	catch(java.lang.Exception ex) {
	    System.out.println(ex);
	}
    }
}
