import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class InstallSsonet extends WindowAdapter implements ActionListener {
    String sourceDirName, destDirName;
    JTextField dlgTextField = new JTextField ("C:\\SSONET",20);
    JDialog dlg;

    void createBatch (String bat) {
        File batchFile = new File (destDirName+"\\"+bat+".bat");
        if (batchFile.exists()) {
            batchFile.delete();
            try {
                batchFile.createNewFile();
            } catch (IOException ioe) {
                ioe.printStackTrace();
                System.out.println ("Could not create "+bat+".bat");
            }
        }
        try {
            PrintStream jp = new PrintStream(new FileOutputStream(batchFile));
            jp.println ("%COMSPEC% /E:4096 /C "+sourceDirName+"\\batch\\"+bat+".bat "+destDirName+"\\ %1 %2 %3 %4 %5");
            jp.close();
        } catch (IOException ioe) {
            ioe.printStackTrace();
            System.out.println ("Could not create JPATH.BAT");
        }
    }

    public static void main (String[] args) {
        // Als Parameter Zielverzeichnis angegeben?
        if (args.length > 0) {
            InstallSsonet i = new InstallSsonet(args[1]);
        } else {
            InstallSsonet i = new InstallSsonet("");
        }
    }

    InstallSsonet (String dest) {
        sourceDirName = System.getProperty("user.dir");
        if (sourceDirName.charAt(sourceDirName.length()-1) == '\\') sourceDirName = sourceDirName.substring(0,sourceDirName.length()-1);
        if (!dest.equals ("")) {
            destDirName = dest;
        } else {
            dlg = new JDialog();
            dlg.setTitle ("Installation for SSONET-Project");
            dlg.getContentPane().setLayout(new BorderLayout());
            JLabel dlgLabel = new JLabel ("Please enter destination Directory");
            dlg.getContentPane().add (dlgLabel,BorderLayout.NORTH);
            dlgTextField.addActionListener (this);
            dlg.getContentPane().add (dlgTextField,BorderLayout.WEST);
            JButton dlgButton = new JButton ("Start");
            dlg.getContentPane().add (dlgButton,BorderLayout.EAST);
            dlgButton.addActionListener (this);
            dlg.pack();
            dlg.setLocationRelativeTo(null);
            dlg.setResizable(false);
            dlg.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
            dlg.addWindowListener(this);
            System.out.println ("Please enter now the destination for SSONET-Config-Files");
            dlg.show();
        }
    }

    public void windowClosing(WindowEvent we) {
        System.out.println ("Installation aborted.");
        System.exit (2);
    }

    public void actionPerformed(ActionEvent e) {
        destDirName = dlgTextField.getText();
        dlg.dispose();
        destDirName = destDirName.trim();
        if (destDirName.equals("")) destDirName = "C:\\SSONET";
        if (destDirName.charAt(1) != ':') destDirName = sourceDirName.substring(0,1)+destDirName;
        if (destDirName.charAt(destDirName.length()-1) == '\\') destDirName = destDirName.substring(0,destDirName.length()-1);
        destDirName = destDirName.toUpperCase();
        System.out.println ("using as Destination: "+destDirName);
        (new File (destDirName)).mkdirs();

        // install.jar - Installation preparieren. (Batch anlegen, die von install.bat aufgerufen wird)
        try {
            String temp = System.getProperty("TEMP","C:");
            if (temp.charAt(temp.length()-1) == '\\') temp = temp.substring(0,temp.length()-1);
            System.out.println ("creating installjar.bat into Tempdir (assuming:"+temp+")...");
            PrintStream install = new PrintStream(new FileOutputStream(new File(temp+"\\installjar.bat")));
            install.println("@"+sourceDirName+"\\unzip32.exe -o "+sourceDirName+"\\install.jar -d "+destDirName+" >nul");
            install.close();
        } catch (IOException ioe) {
            ioe.printStackTrace();
            System.out.println ("Could not create installjar.bat");
        }


        // creating batches
        File jpath = new File (destDirName+"\\jpath.bat");
        if (jpath.exists()) {
            jpath.delete();
            try {
                jpath.createNewFile();
            } catch (IOException ioe) {
                ioe.printStackTrace();
                System.out.println ("Could not create JPATH.BAT");
            }
        }
        try {
            PrintStream jp = new PrintStream(new FileOutputStream(jpath));
            jp.println ("@echo off");
            jp.println ("set classpath=");
            jp.println ("set jdk_lib="+sourceDirName+"\\jre\\lib\\");
            jp.println ("set JAVA_BIN="+sourceDirName+"\\jre\\bin\\");
            jp.println ("set SSONET_CFG="+destDirName+"\\cfg\\");
            jp.println ("set SSONET_CD="+sourceDirName+"\\");
            jp.println ();
            jp.println ("set cryptix="+sourceDirName+"\\cryptix310\\classes\\");
            jp.println ("set cryptix_libs=%cryptix%ALG_0-1-0.jar;%cryptix%ELGAMAL_0-1-0.jar;%cryptix%IJCE_0-1-0.jar;%cryptix%OLD_0-1-4.jar;%cryptix%PGP26_0-1-0.jar;%cryptix%RSA_0-1-0.jar;%cryptix%SPT_0-1-0.jar;%cryptix%TOOLS_0-1-0.jar");
            jp.println ("set ssonet_jar=%SSONET_CD%ssonet.jar");
            jp.println ();
            jp.println ("if exist %SSONET_CFG%ssonet.jar set ssonet_jar=%SSONET_CFG%ssonet.jar");
            jp.println ();
            jp.println ("set classpath=%SSONET_CFG%classes;%ssonet_jar%;%cryptix_libs%;%jdk_lib%rt.jar;%SSONET_CD%jh.jar");
            jp.println ();
            jp.println ("@set jdk_lib=");
            jp.println ("@set cryptix_home=");
            jp.println ("@set cryptix_libs=");
            jp.println ("@set ssonet_jar=");
            jp.println ();
            jp.println ();
            jp.println ("if \"%classpath%\" == \"\" goto nomem");
            jp.println ("goto end");
            jp.println (":nomem");
            jp.println ("echo.");
            jp.println ("echo ****************************************************************************");
            jp.println ("echo Es ist kein Speicher mehr im Umgebungsbereich verfuegbar. Um dieses Problem");
            jp.println ("echo zu beheben, bitte entweder (nur Win95 oder Win98) in die Datei C:\\CONFIG.SYS");
            jp.println ("echo folgende Zeile einfuegen und Rechner neu starten:");
            jp.println ();
            jp.println ("echo shell=C:\\COMMAND.COM C:\\ /p /e:4096");
            jp.println ("echo ****************************************************************************");
            jp.println ("echo.");
            jp.println (":end");
            jp.close();
        } catch (IOException ioe) {
            ioe.printStackTrace();
            System.out.println ("Could not create JPATH.BAT");
        }
        createBatch ("blitz");
        createBatch ("c");
        createBatch ("elegant");
        createBatch ("gk");
        createBatch ("goals");
        createBatch ("gateway");
//        createBatch ("gwacc");
        createBatch ("kunde");
        createBatch ("s");
        createBatch ("stree");
        System.exit(0);
    }
}
