/*
 * catalog/awt/FixedSizeJLabel.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package catalog.awt;

import java.awt.Dimension;

import javax.swing.JLabel;

/**
* A label with fixed size
*/
public	class FixedSizeJLabel extends JLabel {
    int x;
    int y;

    /**
    * creates a label with fixed size, where a and b are
    * the dimensions
    */
    public FixedSizeJLabel(int a, int b)	{
	x=a;
	y=b;
    }

    /**
    * returns the preferred size of the label
    */
    public Dimension getPreferredSize() {
	return new Dimension(x, y);
    }

    /**
    * returns the minimal size of the label
    */
    public Dimension getMinimumSize() {
	return new Dimension(x, y);
    }

    /**
    * returns the maximal size of the label
    */
    public Dimension getMaximumSize() {
	return new Dimension(x, y);
    }
}
