/*
 * catalog/awt/MerchantListFrame.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package catalog.awt;

import catalog.awt.OrderPanel;
import catalog.customer.Customer;
import catalog.net.CatalogFile;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

/**
* A list of merchants
*/
public class MerchantListFrame extends JDialog implements ActionListener, ItemListener {
    private String merchantList[][];
    private int MAX_MERCHANT = 20;
    private int numberOfMerchants;
    private Customer customer;

    public OrderPanel orderPanel;

    /**
    * creates a list of merchantsfor the customer, modal to the orderPanel
    */
    public MerchantListFrame(Customer customer, OrderPanel orderPanel) {
	super(new JFrame(),"Hndlerauswahl", true);
	this.orderPanel = orderPanel;
	this.customer = customer;
	GridBagLayout gridBagLayout = new GridBagLayout();
	GridBagConstraints gridBagConstraints = new GridBagConstraints();
	getContentPane().setLayout(gridBagLayout);
	JLabel label = new JLabel("Hndler URL : Portnummer");
	gridBagConstraints.insets.top = 10;
	gridBagConstraints.insets.left = 10;
	gridBagConstraints.insets.right = 10;
	gridBagConstraints.gridx = 0;
	gridBagConstraints.gridy = 0;
	gridBagConstraints.gridwidth = 2;
	gridBagConstraints.anchor = GridBagConstraints.NORTHWEST;
	gridBagConstraints.weightx = 1;
	gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
	gridBagLayout.setConstraints(label, gridBagConstraints);
	getContentPane().add(label);

	location = new JLabel();
	location.setFont(new Font("Dialog", Font.BOLD,14));
	gridBagConstraints.insets.left = 20;
	gridBagConstraints.gridx = 0;
	gridBagConstraints.gridy = 1;
	gridBagConstraints.gridwidth = 2;
	gridBagConstraints.anchor = GridBagConstraints.NORTHWEST;
	gridBagConstraints.weightx = 1;
	gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
	gridBagLayout.setConstraints(location, gridBagConstraints);
	getContentPane().add(location);

	label = new JLabel("Bitte whlen Sie einen Hndlernamen aus:");
	gridBagConstraints.gridx = 0;
	gridBagConstraints.gridy = 2;
	gridBagConstraints.insets.left = 10;
	gridBagConstraints.gridwidth = 2;
	gridBagConstraints.anchor = GridBagConstraints.NORTHWEST;
	gridBagConstraints.weightx = 1;
	gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
	gridBagLayout.setConstraints(label, gridBagConstraints);
	getContentPane().add(label);

	choice1 = new JComboBox();
	gridBagConstraints.gridx = 0;
	gridBagConstraints.gridy = 3;
	gridBagConstraints.gridwidth = 2;
	gridBagConstraints.anchor = GridBagConstraints.NORTHWEST;
	gridBagConstraints.weightx = 1;
	gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
	gridBagLayout.setConstraints(choice1, gridBagConstraints);
	getContentPane().add(choice1);

	quitButton = new JButton("Abbrechen");
	gridBagConstraints.insets.top = 20;
	gridBagConstraints.insets.bottom = 20;
	gridBagConstraints.ipadx = 20;
	gridBagConstraints.ipady = 10;
	gridBagConstraints.gridx = 1;
	gridBagConstraints.gridy = 4;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.anchor = GridBagConstraints.NORTHWEST;
	gridBagConstraints.weightx = 0.5;
	gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
	gridBagLayout.setConstraints(quitButton, gridBagConstraints);
	getContentPane().add(quitButton);

	okButton = new JButton("Katalog online laden.");
	gridBagConstraints.gridx = 0;
	gridBagConstraints.gridy = 4;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.anchor = GridBagConstraints.NORTHWEST;
	gridBagConstraints.weightx = 0.5;
	gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
	gridBagLayout.setConstraints(okButton, gridBagConstraints);
	getContentPane().add(okButton);

	pack();
	setResizable(false);

	Point parentLocation = customer.getLocationOnScreen();
	Dimension parentDimension = customer.getSize();
	Dimension ownDimension = this.getSize();
	int x = 0;
	int y = 0;
	x = parentLocation.x + (parentDimension.width - ownDimension.width) / 2;
	y = parentLocation.y + (parentDimension.height - ownDimension.height) / 2;
	setLocation(x, y);

	okButton.addActionListener(this);
	quitButton.addActionListener(this);
	choice1.addItemListener(this);

	int number = 0;
	BufferedReader merchantFile;
	merchantList = new String[3][MAX_MERCHANT];
	try {
	    merchantFile = new BufferedReader(new FileReader(System.getProperty("ssonet_cfg")+"catalog/Haendler_list.sock"));
	    while (number<MAX_MERCHANT) {
		merchantList[0][number] = merchantFile.readLine();
		merchantList[1][number] = merchantFile.readLine();
		merchantList[2][number] = merchantFile.readLine();
		if ((merchantList[0][number] == null)||(merchantList[1][number] == null)||(merchantList[2][number] == null))
		    break;
		choice1.addItem(merchantList[0][number]);
		number++;
            }
	    location.setText(merchantList[1][0] + " : " + merchantList[2][0]);
	    choice1.setSelectedIndex(0);
	    merchantFile.close();
        }
	catch (Exception e) {
	    System.out.println("Fehler in readMerchantList:" + e);
	}
	numberOfMerchants = number;
    }

    JComboBox choice1;
    JButton quitButton;
    JButton okButton;
    JLabel location;

    /**
    * handles ActionListeners calls
    */
    public void actionPerformed(java.awt.event.ActionEvent event) {
	Object object = event.getSource();
	if (object == okButton)
	    okButtonAction(event);
	else if (object == quitButton)
	    quitbuttonAction(event);
    }

    /**
    * marked merchant is choosen
    */
    void okButtonAction(java.awt.event.ActionEvent event) {
	int portNumber;
	int position = choice1.getSelectedIndex();
	if ((position < 0) || (position > numberOfMerchants)) {
	    System.out.println("Falsche Auswahl in MerchantListFrame!");
	    return;
	}
	System.out.println("MerchantName: >" + merchantList[0][position] + "<");
	System.out.println("MerchantHost: >" + merchantList[1][position] + "<");
	try {
	    portNumber = (new Integer(merchantList[2][position])).intValue();
	} catch (Exception e) {
	    System.out.println("Fehler in Portnummer:" + e);
	    return;
	}
	dispose();
	System.out.println("Portnummer: >" + portNumber + "<");
	if (!customer.requestCatalog(customer.frame, merchantList[0][position],
	    merchantList[1][position], portNumber)) {
	    JOptionPane.showMessageDialog(customer.frame,
		"Konnte nicht verbinden",
		"Fehler",
		JOptionPane.INFORMATION_MESSAGE);
	}
	dispose();
    }

    /**
    * the frame will be closed
    */
    void quitbuttonAction(java.awt.event.ActionEvent event) {
	dispose();
    }

    /**
    * is called when the state of the frame is changed
    * refreshes the mark and the text
    */
    public void itemStateChanged(java.awt.event.ItemEvent event) {
	int position = choice1.getSelectedIndex();
	location.setText(merchantList[1][position] + " : " + merchantList[2][position]);
	validate();
    }
}
