/*
 * catalog/awt/ProductPanel.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package catalog.awt;

import catalog.awt.FixedSizeJLabel;
import catalog.zip.Zip;

import java.awt.Image;
import java.awt.Toolkit;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;
import javax.swing.border.EtchedBorder;


/**
* A panel with information for an article
*/
public class ProductPanel extends JPanel {
    private ImageIcon icon;
    private JLabel imageLabel;
    private ImageIcon defaultImage = new ImageIcon(getClass().getResource("images/ssonet.gif"));
    JTextArea textField1;

    /**
    * erzeugt das Panel, in dem Informationen zu einem Artikel angezeigt werden
    */
    public ProductPanel(JTextArea textField1) {
	this.textField1 = textField1;
	setBorder(new EtchedBorder(5));
	imageLabel = new FixedSizeJLabel(200,200);
	imageLabel.setHorizontalAlignment(SwingConstants.CENTER);
	imageLabel.setVerticalAlignment(SwingConstants.CENTER);
	add(imageLabel);
    }

    public void set(int row, String amount, String orderNumber)
    {
        String text;
        Zip zip = new Zip();
        zip.open();
        try {
            if ((text = zip.getInfoText(orderNumber)) == null) {
                textField1.setText("Leider kein Werbetext auffindbar!");
            } else {
                textField1.setText(text);
            }
            byte pictureBytes[];
            if ((pictureBytes = zip.getPicture(orderNumber)) == null) {
                icon = defaultImage;
                System.out.println("Bild nicht gefunden.");
            } else {
                Image image = Toolkit.getDefaultToolkit().createImage(pictureBytes);
                int scalex = 0;
                int scaley = 0;
                icon = new ImageIcon(image);
            }
            imageLabel.setIcon(icon);
            icon.setImageObserver(this);
        }
        catch (Exception e) {
            System.out.println("Exception in ProductPanel:"+e);
        }
        zip.close();
    }
}

