/*
 * client_server/Server.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package client_server;

import javax.swing.JFrame;

import smi.appConf.ApplicationConfiguration;
import smi.appConf.ActionConfiguration;
import smi.io.IOStream;

import ssonet.SSONETConnection;
import ssonet.SSONETServerConnection;
import ssonet.Preload;
import ssonet.SSONETConstraints;

public class Server extends JFrame
{
    Preload p = new Preload();
    // Action-ID
    private static final short HELLO_WORLD = 1;

    static public void main(String[] argv)
    {
	new Server();
    }

    private Server() {
	try {
	    System.out.println("Configure Action.");

	    // configure Action
	    if (smi.appConf.ApplicationConfiguration.getActionConfiguration("Server", HELLO_WORLD)==null) {
		System.out.println("No ActionConfiguration found.");
		SSONETConstraints configurationConstraints = new SSONETConstraints();
		ApplicationConfiguration.configureAction(this,"Server","Hello World", HELLO_WORLD,
		    configurationConstraints);
	    }
	    System.out.println("create Server Socket");

	    // create Server Socket
	    SSONETServerConnection ssonetServerConnection = new SSONETServerConnection("Server", this,2000);

	    // wait for connections -> Negotiation
	    System.out.println("Wait for Connections.");
	    IOStream ioStream = ssonetServerConnection.accept();
	    System.out.println("Connected.");

	    // answer Object
	    int messages=0;
	    while(true)
	    {
		try {
		    if(ioStream.available()==0)
		    {
			Object obj = ioStream.readObject();
			messages++;
			ioStream.writeObject(obj);
			//System.out.println("Object read");
		    }
		} catch(Exception e) {
		    System.out.println("Connection terminated!");
		    e.printStackTrace();
		    System.out.println("Received messages: "+messages);
		    System.exit(0);
		}
	    }
	} catch(Exception e) {
	    e.printStackTrace();
	}
    }
}
