/*
 * goals/SecuritySettings.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package goals;

import java.io.Serializable;

public class SecuritySettings implements Serializable {
    public static final int HIGH = 0;
    public static final int MIDDLE = 1;
    public static final int LOW = 2;
    public static final int USER_DEFINED = 3;

    private String name;
    private int securityLevel;
    private int[][] defaultValues = {
	{1,2,1,1,5,1,1,5,1,1,3},
	{2,2,2,2,4,2,2,4,2,2,3},
	{4,4,4,4,2,4,4,2,3,4,3}};
    private int[] userDefinedValues;

    public SecuritySettings(String name) {
	this.name = name;
	setSecurityLevel(MIDDLE);
    }

    public void setUserDefinedValues(int[] values) {
	userDefinedValues = values;
    }

    public int[] getUserDefinedValues() {
	return userDefinedValues;
    }

    public void setSecurityLevel(int level) {
	securityLevel = level;
	if (level != USER_DEFINED) userDefinedValues = defaultValues[level];
    }

    public int getSecurityLevel() {
	return securityLevel;
    }

    public String toString() {
	return name;
    }
}
