/*
 * smi/baseConf/StartUp.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package smi.baseConf;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.util.Hashtable;
import java.util.Properties;
import java.util.StringTokenizer;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.SwingConstants;
import javax.swing.border.TitledBorder;

import smi.mechanisms.Mix;

public class StartUp extends Thread implements ActionListener {

    class MixPing extends Thread {
	private Mix mix;
	private boolean available = false;
	public MixPing(ThreadGroup threadGroup, String threadName, Mix mix) {
	    super(threadGroup, threadName);
	    this.mix = mix;
	}

	public void run() {
	    available = mix.available();
	    System.out.println(available);
	}

	public boolean getAvailable() {
	    return available;
	}
    }
    private String[]
	confidentialityMechanisms,
	integrityMechanisms,
	mixes,
	signMechanisms;

    private JLabel label1, label2, label3, label4, label5, label6, label7, label8, label9, label10, label11, label12;
    private JLabel label1Icon, label2Icon, label3Icon, label4Icon, label5Icon, label6Icon;
    private ImageIcon emptyIcon, arrowIcon;
    private JButton cancelButton;
    private JProgressBar progressBar;
    private JFrame frame;
    private String directory;
    private Hashtable configuration;
    private JDialog dialog;

    public String[] getMechanisms() {
	return confidentialityMechanisms;
    }

    public String[] getMechanismsIntegrity() {
	return integrityMechanisms;
    }

    public String[] getSignatures() {
	return signMechanisms;
    }

    public String[] getMixe() {
	return mixes;
    }

    public static boolean writeBaseConfiguration(Hashtable configuration) {
	try {
	    ObjectOutputStream objectOutputStream =
		new ObjectOutputStream(new FileOutputStream(new File(System.getProperty("ssonet_cfg"),"baseConfig.dat")));
	    objectOutputStream.writeObject(configuration);
	    objectOutputStream.flush();
	    objectOutputStream.close();
	    return true;
	} catch(Exception e) {
	    return false;
	}
    }

    public static Hashtable getBaseConfiguration() {
	try {
	    return (Hashtable)(new ObjectInputStream(new FileInputStream
		(new File(System.getProperty("ssonet_cfg"),
		"baseConfig.dat")))).readObject();
	} catch(Exception e) {
	    return null;
	}
    }

    private  void create() {
	GridBagLayout gridBagLayout = new GridBagLayout();
	GridBagConstraints gridBagConstraints = new GridBagConstraints();

	JPanel panel = new JPanel();
	panel.setDoubleBuffered(false);
	panel.setLayout(gridBagLayout);
	panel.setBorder(new TitledBorder("Initialize"));

	label1Icon = new JLabel(emptyIcon);
	gridBagConstraints.insets = new Insets(15,10,0,0);
	gridBagConstraints.anchor = GridBagConstraints.WEST;
	gridBagConstraints.gridx = 0;
	gridBagConstraints.gridy = 0;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label1Icon, gridBagConstraints);
	panel.add(label1Icon);

	label1 = new JLabel("1. Search for installed mechanisms.");
	gridBagConstraints.insets = new Insets(15,5,0,0);
	gridBagConstraints.anchor = GridBagConstraints.WEST;
	gridBagConstraints.gridx = 1;
	gridBagConstraints.gridy = 0;
	gridBagConstraints.gridwidth = 3;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label1, gridBagConstraints);
	panel.add(label1);

	label1Icon = new JLabel(emptyIcon);
	gridBagConstraints.insets = new Insets(10,10,0,0);
	gridBagConstraints.anchor = GridBagConstraints.WEST;
	gridBagConstraints.gridx = 1;
	gridBagConstraints.gridy = 1;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label1Icon, gridBagConstraints);
	panel.add(label1Icon);

	label2 = new JLabel("1.1 Confidentiality");
	gridBagConstraints.insets = new Insets(10,5,0,0);
	gridBagConstraints.anchor = GridBagConstraints.WEST;
	gridBagConstraints.gridx = 2;
	gridBagConstraints.gridy = 1;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label2, gridBagConstraints);
	panel.add(label2);

	label6 = new JLabel();
	gridBagConstraints.insets = new Insets(10,20,0,10);
	gridBagConstraints.anchor = GridBagConstraints.EAST;
	gridBagConstraints.gridx = 3;
	gridBagConstraints.gridy = 1;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 1;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label6, gridBagConstraints);
	panel.add(label6);

	label2Icon = new JLabel(emptyIcon);
	gridBagConstraints.insets = new Insets(10,10,0,0);
	gridBagConstraints.anchor = GridBagConstraints.WEST;
	gridBagConstraints.gridx = 1;
	gridBagConstraints.gridy = 2;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label2Icon, gridBagConstraints);
	panel.add(label2Icon);

	label3 = new JLabel("1.2 Anonymity");
	gridBagConstraints.insets = new Insets(10,5,0,0);
	gridBagConstraints.anchor = GridBagConstraints.WEST;
	gridBagConstraints.gridx = 2;
	gridBagConstraints.gridy = 2;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label3, gridBagConstraints);
	panel.add(label3);

	label7 = new JLabel();
	gridBagConstraints.insets = new Insets(10,20,0,10);
	gridBagConstraints.anchor = GridBagConstraints.EAST;
	gridBagConstraints.gridx = 3;
	gridBagConstraints.gridy = 2;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 1;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label7, gridBagConstraints);
	panel.add(label7);

	label5Icon = new JLabel(emptyIcon);
	gridBagConstraints.insets = new Insets(10,10,0,0);
	gridBagConstraints.anchor = GridBagConstraints.WEST;
	gridBagConstraints.gridx = 1;
	gridBagConstraints.gridy = 3;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label5Icon, gridBagConstraints);
	panel.add(label5Icon);

	label9 = new JLabel("1.3 Integrity");
	gridBagConstraints.insets = new Insets(10,5,0,0);
	gridBagConstraints.anchor = GridBagConstraints.WEST;
	gridBagConstraints.gridx = 2;
	gridBagConstraints.gridy = 3;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label9, gridBagConstraints);
	panel.add(label9);

	label10 = new JLabel();
	gridBagConstraints.insets = new Insets(10,20,0,10);
	gridBagConstraints.anchor = GridBagConstraints.EAST;
	gridBagConstraints.gridx = 3;
	gridBagConstraints.gridy = 3;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 1;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label10, gridBagConstraints);
	panel.add(label10);

	label6Icon = new JLabel(emptyIcon);
	gridBagConstraints.insets = new Insets(10,10,0,0);
	gridBagConstraints.anchor = GridBagConstraints.WEST;
	gridBagConstraints.gridx = 1;
	gridBagConstraints.gridy = 4;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label6Icon, gridBagConstraints);
	panel.add(label6Icon);

	label11 = new JLabel("1.4 Accountability");
	gridBagConstraints.insets = new Insets(10,5,0,0);
	gridBagConstraints.anchor = GridBagConstraints.WEST;
	gridBagConstraints.gridx = 2;
	gridBagConstraints.gridy = 4;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label11, gridBagConstraints);
	panel.add(label11);

	label12 = new JLabel();
	gridBagConstraints.insets = new Insets(10,20,0,10);
	gridBagConstraints.anchor = GridBagConstraints.EAST;
	gridBagConstraints.gridx = 3;
	gridBagConstraints.gridy = 4;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 1;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label12, gridBagConstraints);
	panel.add(label12);

	label3Icon = new JLabel(emptyIcon);
	gridBagConstraints.insets = new Insets(20,10,0,0);
	gridBagConstraints.anchor = GridBagConstraints.WEST;
	gridBagConstraints.gridx = 0;
	gridBagConstraints.gridy = 5;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label3Icon, gridBagConstraints);
	panel.add(label3Icon);

	label4 = new JLabel("2. Check for available mixes");
	gridBagConstraints.insets = new Insets(20,5,0,0);
	gridBagConstraints.anchor = GridBagConstraints.WEST;
	gridBagConstraints.gridx = 1;
	gridBagConstraints.gridy = 5;
	gridBagConstraints.gridwidth = 3;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label4, gridBagConstraints);
	panel.add(label4);

	label4Icon = new JLabel(emptyIcon);
	gridBagConstraints.insets = new Insets(20,10,20,0);
	gridBagConstraints.anchor = GridBagConstraints.WEST;
	gridBagConstraints.gridx = 0;
	gridBagConstraints.gridy = 6;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label4Icon, gridBagConstraints);
	panel.add(label4Icon);

	label5 = new JLabel("3. Load configuration");
	gridBagConstraints.insets = new Insets(20,5,20,0);
	gridBagConstraints.anchor = GridBagConstraints.WEST;
	gridBagConstraints.gridx = 1;
	gridBagConstraints.gridy = 6;
	gridBagConstraints.gridwidth = 3;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label5, gridBagConstraints);
	panel.add(label5);

	Container dialogContainer = dialog.getContentPane();
	dialogContainer.setLayout(gridBagLayout);

	gridBagConstraints.insets = new Insets(10,10,10,10);
	gridBagConstraints.anchor = GridBagConstraints.NORTH;
	gridBagConstraints.gridx = 0;
	gridBagConstraints.gridy = 0;
	gridBagConstraints.gridwidth = 2;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 1;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(panel, gridBagConstraints);
	dialogContainer.add(panel);

	label8 = new JLabel("Progress:");
	gridBagConstraints.insets = new Insets(10,10,0,0);
	gridBagConstraints.anchor = GridBagConstraints.WEST;
	gridBagConstraints.gridx = 0;
	gridBagConstraints.gridy = 1;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(label8, gridBagConstraints);
	dialogContainer.add(label8);

	progressBar = new JProgressBar();
	progressBar.setDoubleBuffered(true);
	progressBar.setMinimum(0);
	progressBar.setMaximum(15);
	gridBagConstraints.insets = new Insets(10,10,0,10);
	gridBagConstraints.anchor = GridBagConstraints.NORTHWEST;
	gridBagConstraints.gridx = 1;
	gridBagConstraints.gridy = 1;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
	gridBagConstraints.ipadx = 0;
	gridBagConstraints.ipady = 0;
	gridBagConstraints.weightx = 1;
	gridBagConstraints.weighty = 0;
	gridBagLayout.setConstraints(progressBar, gridBagConstraints);
	dialogContainer.add(progressBar);

	cancelButton = new JButton("Cancel");
	gridBagConstraints.insets = new Insets(20,0,20,0);
	gridBagConstraints.anchor = GridBagConstraints.NORTH;
	gridBagConstraints.gridx = 0;
	gridBagConstraints.gridy = 2;
	gridBagConstraints.gridwidth = 2;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.ipadx = 15;
	gridBagConstraints.ipady = 5;
	gridBagConstraints.weightx = 1;
	gridBagConstraints.weighty = 1;
	gridBagLayout.setConstraints(cancelButton, gridBagConstraints);
	dialogContainer.add(cancelButton);
	cancelButton.addActionListener(this);
    }

    public StartUp(JFrame frame) {
	this.frame = frame;
    }

    private String[] getTokenized (String s) {
	StringTokenizer st = new StringTokenizer(s);
	String[] ret = new String[st.countTokens()];
	int i = 0;
	while (st.hasMoreTokens()) {
	    ret[i++] = st.nextToken();
	}
	return ret;
    }


    public void run() {
	dialog = new JDialog(frame,"Base configuration start.", false);
	emptyIcon = new ImageIcon(getClass().getResource("images/empty.gif"));
	arrowIcon = new ImageIcon(getClass().getResource("images/pfeil.gif"));
	create();
	dialog.pack();

	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	Dimension ownDimension = dialog.getSize();
	dialog.setBounds((screenSize.width - ownDimension.width) / 2 - 300,
	    (screenSize.height - ownDimension.height) / 2,
	    ownDimension.width + 150,
	    ownDimension.height);
	dialog.show();

	int sleepTime = 800;
	Font plainFont = label2.getFont();
	Font boldFont = new Font(label2.getFont().getName(), Font.BOLD,
	    label2.getFont().getSize());

	BufferedReader availableFile = null;
	try {
	    availableFile = new BufferedReader(new FileReader(System.getProperty ("ssonet_cfg")+"smi/mechanisms/available"));
	} catch (FileNotFoundException fnfe) {
	    System.out.println (System.getProperty ("ssonet_cfg")+"smi/mechanisms/available not found.");
	    System.exit (-1);
	}
	System.out.println("Using "+System.getProperty ("ssonet_cfg")+"smi/mechanisms/available as reference for available mechanisms.");
	String s;

	// 1. --> find confidentiality mechansims
	label1Icon.setIcon(arrowIcon);
	label2.setFont(boldFont);

	// search through availables Mechanisms
	s = "";
	try {
	    while ((s.trim() == "") || ((s.trim()).charAt(0) == '#'))
	    {
		s = availableFile.readLine();
	    }
	} catch (IOException ioe) {
	    s = "";
	}
	confidentialityMechanisms = getTokenized (s);

	try {
	    sleep(sleepTime);
	} catch(Exception e) {
	    e.printStackTrace ();
	}
	label6.setText(Integer.toString(confidentialityMechanisms.length) + " mechanisms found");
	progressBar.setValue(1);
	label1Icon.setIcon(emptyIcon);
	label2.setFont(plainFont);

	// 2. --> find mixes
	label2Icon.setIcon(arrowIcon);
	label3.setFont(boldFont);
	try {
	    sleep(sleepTime);
	} catch(Exception e) {
	    System.out.println(e);
	}

	// search through availables Mixes
	s = "";
	try {
	    while ((s.trim() == "") || ((s.trim()).charAt(0) == '#'))
	    {
		s = availableFile.readLine();
	    }
	} catch (IOException ioe) {
	    s = "";
	}
	mixes = getTokenized (s);

	label7.setText(Integer.toString(mixes.length) + " mixes found");
	progressBar.setValue(2);
	label2Icon.setIcon(emptyIcon);
	label3.setFont(plainFont);

	// 3. --> find integrity mechansims
	label5Icon.setIcon(arrowIcon);
	label9.setFont(boldFont);

	// search through availables Mechanisms
	s = "";
	try {
	    while ((s.trim() == "") || ((s.trim()).charAt(0) == '#'))
	    {
		s = availableFile.readLine();
	    }
	} catch (IOException ioe) {
	    s = "";
	}
	integrityMechanisms = getTokenized (s);

	try {
	    sleep(sleepTime);
	} catch(Exception e) {
	    System.out.println(e);
	}
	label10.setText(Integer.toString(integrityMechanisms.length) + " mechanisms found");
	progressBar.setValue(3);
	label5Icon.setIcon(emptyIcon);
	label9.setFont(plainFont);

	// 4. --> find accountability mechansims
	label6Icon.setIcon(arrowIcon);
	label11.setFont(boldFont);

	// search through availables Mechanisms
	s = "";
	try {
	    while ((s.trim() == "") || ((s.trim()).charAt(0) == '#'))
	    {
		s = availableFile.readLine();
	    }
	} catch (IOException ioe) {
	    s = "";
	}
	signMechanisms = getTokenized (s);

	try {
	    sleep(sleepTime);
	} catch(Exception e) {
	    System.out.println(e);
	}
	label12.setText(Integer.toString(signMechanisms.length) + " sign mechanisms found");
	progressBar.setValue(4);
	label6Icon.setIcon(emptyIcon);
	label11.setFont(plainFont);

	//---- check mixes
	label3Icon.setIcon(arrowIcon);
	label4.setFont(boldFont);

	class PingAllMixes extends Thread {
	    private Mix mixe[];
	    private ThreadGroup threadGroup;
	    public PingAllMixes() {
	    }

	    public void run() {
		threadGroup = new ThreadGroup("PingAllMixe");
		mixe = new Mix[mixes.length];
		MixPing[] pingthreads = new MixPing[mixes.length];
		for(int i = 0; i < mixes.length; i++) {
		    try {
			mixe[i] = (Mix)Class.forName("smi.mechanisms.anonymity." + mixes[i]).newInstance();
		    } catch (Exception e) {
			System.out.println(e);
		    }
		    pingthreads[i] = new MixPing(threadGroup, mixes[i], mixe[i]);
		    pingthreads[i].start();
		}
		for(int i = 5; i < 15; i++) {
		    try {
			this.sleep(400);
		    } catch (Exception e) {
			System.out.println(e);
		    }
		    if(threadGroup.activeCount() == 0)
			break;
		    progressBar.setValue(i);
		}
		while(threadGroup.activeCount() > 0) {
		    try {
			this.sleep(400);
		    }
		    catch (Exception e) {
			System.out.println(e);
		    }
		}
		progressBar.setValue(14);
	    }
	}
	PingAllMixes pingAllMixes = new PingAllMixes();
	pingAllMixes.start();
	try {
	    pingAllMixes.join();
	} catch (Exception e) {
	    System.out.println(e);
	}

	label3Icon.setIcon(emptyIcon);
	label4.setFont(plainFont);


	// load confiugration
	label4Icon.setIcon(arrowIcon);
	label5.setFont(boldFont);
	configuration = getBaseConfiguration();
	try {
	    sleep(400);
	} catch(Exception e) {
	    System.out.println(e);
	}
	progressBar.setValue(15);
	dialog.dispose();
    }

    public void actionPerformed(ActionEvent e) {
	dialog.dispose();
	System.exit(0);
    }
}
