/*
 * smi/mechanisms/Mechanism.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package smi.mechanisms;

import java.io.InputStream;
import java.io.OutputStream;
import java.security.PublicKey;

import javax.swing.JFrame;

import smi.io.IOStream;
import smi.mechanisms.MechanismConfiguration;
import smi.mechanisms.ParameterNotCompatibleException;

import ssonet.KeyExchange;

import sun.security.x509.X509Cert;

public interface Mechanism extends IOStream {

    public String[] getModes();

    public MechanismConfiguration getDefaultConfiguration();

    public MechanismConfiguration configDetail(JFrame parentFrame,
	MechanismConfiguration actualMechanismConfiguration);

    public void init(IOStream ioStream,
	MechanismConfiguration ownMechanismConfiguration);

    public void init(IOStream ioStream,
	MechanismConfiguration ownMechanismConfiguration,
	MechanismConfiguration partnerMechanismConfiguration,
	KeyExchange keyExchange) throws Exception;

    public byte[] testEncrypt(byte[] buffer);

    public byte[] testDecrypt(byte[] buffer);
}
