/*
 * experimental source code
 * sproxy/awt/ClientConfigDialog.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package sproxy.awt;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import sproxy.client.AbstractClient;
import sproxy.client.UniClient;

public class ClientConfigDialog extends JDialog implements ActionListener {

    protected JTextField lokalerPort, appName, transID, ssonetServer, ssonetPort;
    public boolean status;

    public ClientConfigDialog() {
	super((JFrame)null, true);

	// Initialisierungen
	setTitle("Client Konfiguration");
	status = false;

	// Layout
	GridBagLayout gb       = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();

        getContentPane().setLayout(gb);
        gbc.insets.top   = 10;
        gbc.insets.left  = 10;
        gbc.insets.right = 10;
	gbc.anchor       = GridBagConstraints.WEST;

	// zu belauschender Port
	JLabel jl1 = new JLabel("zu belauschender lokaler Port");
	gbc.gridx =0;
	gbc.gridy =0;
	gb.setConstraints(jl1, gbc);
	getContentPane().add(jl1);

	lokalerPort = new JTextField("4021",15);
	gbc.gridx =1;
	gbc.gridy =0;
	gb.setConstraints(lokalerPort, gbc);
	getContentPane().add(lokalerPort);

	// Name der Anwendung
	jl1 = new JLabel("Name der Anwendung");
	gbc.gridx = 0;
	gbc.gridy = 1;
	gb.setConstraints(jl1, gbc);
	getContentPane().add(jl1);

	appName = new JTextField("test",15);
	gbc.gridx = 1;
	gbc.gridy = 1;
	gb.setConstraints(appName, gbc);
	getContentPane().add(appName);

	// ID
	jl1 = new JLabel("ID");
	gbc.gridx = 0;
	gbc.gridy = 2;
	gb.setConstraints(jl1, gbc);
	getContentPane().add(jl1);

	transID = new JTextField("1",15);
	gbc.gridx = 1;
	gbc.gridy = 2;
	gb.setConstraints(transID, gbc);
	getContentPane().add(transID);

	// SSONET Servername
	jl1 = new JLabel("SSONET Serveradresse");
	gbc.gridx=0;
	gbc.gridy=3;
	gb.setConstraints(jl1, gbc);
	getContentPane().add(jl1);

	ssonetServer = new JTextField("localhost",15);
	gbc.gridx = 1;
	gbc.gridy = 3;
	gb.setConstraints(ssonetServer, gbc);
	getContentPane().add(ssonetServer);

	// SSONET Serverport
	jl1 = new JLabel("SSONET Port");
	gbc.gridx = 2;
	gb.setConstraints(jl1, gbc);
	getContentPane().add(jl1);

	ssonetPort = new JTextField("5021",15);
	gbc.gridx = 3;
	gb.setConstraints(ssonetPort, gbc);
	getContentPane().add(ssonetPort);

	// Buttonpanel
	gbc.gridx     = 1;
	gbc.gridy     = 4;
	gbc.gridwidth = 3;
	gbc.anchor    = GridBagConstraints.EAST;
	Panel q       = ButtonPanel();
	gb.setConstraints(q, gbc);
	getContentPane().add(q);

	pack();
	show();
    }

    // Ein einfaches Panel fuer die Buttons
    protected Panel ButtonPanel() {
	Panel p    = new Panel(); // FlowLayout

	JButton jb = new JButton("Konfiguration");
	p.add(jb);
	jb.addActionListener(this);

	jb = new JButton("Start Client");
	p.add(jb);
	jb.addActionListener(this);

	jb = new JButton("Abbruch");
	p.add(jb);
	jb.addActionListener(this);

	return p;
    }

    protected int lokPort, ssPort, trID;
    protected String ssAd, app;
    protected AbstractClient clConf;

    // ueberprueft die Eingabe auf syntaktische und logische Korrektheit
    protected boolean checkdatas() {

	try {
	    lokPort = (new Integer(lokalerPort.getText())).intValue();
	} catch (Exception e) {
	    JOptionPane.showMessageDialog(this,"Bitte geben Sie als lokalen Port eine Zahl ein","Falsche Eingabe", JOptionPane.ERROR_MESSAGE);
	    return false;
	}

	try {
	    ssPort = (new Integer(ssonetPort.getText())).intValue();
	} catch (Exception e) {
	    JOptionPane.showMessageDialog(this,"Bitte geben Sie als SSONET Port eine Zahl ein","Falsche Eingabe", JOptionPane.ERROR_MESSAGE);
	    return false;
	}

	try {
	    trID = (new Integer(transID.getText())).intValue();
	} catch (Exception e) {
	    JOptionPane.showMessageDialog(this,"Bitte geben Sie als ID eine Zahl ein","Falsche Eingabe", JOptionPane.ERROR_MESSAGE);
	    return false;
	}

	ssAd = ssonetServer.getText();
	app  = appName.getText();


	// jetzt auf logische Fehler achten
	if (lokPort==0) {
	    JOptionPane.showMessageDialog(this,"Der lokale Port darf nicht gleich null sein","Unlogische Eingabe", JOptionPane.ERROR_MESSAGE);
	    return false;
	}
	if (ssPort==0) {
	    JOptionPane.showMessageDialog(this,"Der SSONET Port darf nicht gleich null sein","Unlogische Eingabe", JOptionPane.ERROR_MESSAGE);
	    return false;
	}
	if ((ssAd == null) || (ssAd.length()==0)) {
	    JOptionPane.showMessageDialog(this,"Bitte geben Sie die Adresse des SSONET Servers ein","Fehlende Eingabe", JOptionPane.ERROR_MESSAGE);
	    return false;
	}
	if ((app == null) || (app.length() ==0)) {
	    JOptionPane.showMessageDialog(this,"Bitte geben Sie den Applikationsnamen ein","Fehlende Eingabe", JOptionPane.ERROR_MESSAGE);
	    return false;
	}

	return true;
    }

    public AbstractClient getConfig() {
	return clConf;
    }

    public void actionPerformed(ActionEvent e) {
	String s = e.getActionCommand();

	if (s == "Start Client") {
	    // zuerst die Daten ueberpruefen und setzen
	    if (checkdatas()) {
		status = true;  // mit start beendet
		clConf = new UniClient(lokPort, ssPort, ssAd, app, trID);
		dispose();
	    }
	}
	if (s == "Abbruch") {
	    status = false;
	    dispose();
	}
	if (s == "Konfiguration") {
	    JOptionPane.showMessageDialog(this,"Noch keine Konfiguration implementiert","Fehlender Programmcode", JOptionPane.ERROR_MESSAGE);
	}
    }

}
