/*
 * experimental source code
 * sproxy/awt/ServerConfigDialog.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package sproxy.awt;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import sproxy.server.AbstractServer;
import sproxy.server.UniServer;

public class ServerConfigDialog extends JDialog implements ActionListener {

    protected JTextField lokalerPort, remoteServer, remotePort;
    public boolean status;

    public ServerConfigDialog() {
	super((JFrame)null, true);

	// Initialisierungen
	setTitle("Server Konfiguration");
	status = false;

	// Layout
	GridBagLayout gb       = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();

        getContentPane().setLayout(gb);
        gbc.insets.top   = 10;
        gbc.insets.left  = 10;
        gbc.insets.right = 10;
	gbc.anchor       = GridBagConstraints.WEST;

	// zu belauschender Port
	JLabel jl1 = new JLabel("zu belauschender lokaler SSONET Port");
	gbc.gridx =0;
	gbc.gridy =0;
	gb.setConstraints(jl1, gbc);
	getContentPane().add(jl1);

	lokalerPort = new JTextField("5021",25);
	gbc.gridx =1;
	gbc.gridy =0;
	gb.setConstraints(lokalerPort, gbc);
	getContentPane().add(lokalerPort);

	// Verbindung weiterleiten zu
	jl1 = new JLabel("Verbindung weiterleiten zu");
	gbc.gridx=0;
	gbc.gridy=1;
	gb.setConstraints(jl1, gbc);
	getContentPane().add(jl1);

	remoteServer = new JTextField("irz.inf.tu-dresden.de",25);
	gbc.gridx = 1;
	gbc.gridy = 1;
	gb.setConstraints(remoteServer, gbc);
	getContentPane().add(remoteServer);

	// port des weitergeleiteten Rechners
	jl1 = new JLabel("Port");
	gbc.gridx = 2;
	gb.setConstraints(jl1, gbc);
	getContentPane().add(jl1);

	remotePort = new JTextField("21",15);
	gbc.gridx = 3;
	gb.setConstraints(remotePort, gbc);
	getContentPane().add(remotePort);

	// Buttonpanel
	gbc.gridx     = 1;
	gbc.gridy     = 2;
	gbc.gridwidth = 3;
	gbc.anchor    = GridBagConstraints.EAST;
	Panel q       = ButtonPanel();
	gb.setConstraints(q, gbc);
	getContentPane().add(q);

	pack();
	show();
    }

    // Ein einfaches Panel fuer die Buttons
    protected Panel ButtonPanel() {
	Panel p    = new Panel(); // FlowLayout

	JButton jb = new JButton("Konfiguration");
	p.add(jb);
	jb.addActionListener(this);

	jb = new JButton("Start SSONET Server");
	p.add(jb);
	jb.addActionListener(this);

	jb = new JButton("Abbruch");
	p.add(jb);
	jb.addActionListener(this);

	return p;
    }

    protected int lokPort, rrPort;
    protected String rrAd;
    protected AbstractServer clConf;

    // ueberprueft die Eingabe auf syntaktische und logische Korrektheit
    protected boolean checkdatas() {

	try {
	    lokPort = (new Integer(lokalerPort.getText())).intValue();
	} catch (Exception e) {
	    JOptionPane.showMessageDialog(this,"Bitte geben Sie als lokalen SSONET Port eine Zahl ein","Falsche Eingabe", JOptionPane.ERROR_MESSAGE);
	    return false;
	}

	try {
	    rrPort = (new Integer(remotePort.getText())).intValue();
	} catch (Exception e) {
	    JOptionPane.showMessageDialog(this,"Bitte geben Sie als Port des entfernten Servers eine Zahl ein","Falsche Eingabe", JOptionPane.ERROR_MESSAGE);
	    return false;
	}

	rrAd = remoteServer.getText();

	// jetzt auf logische Fehler achten
	if (lokPort==0) {
	    JOptionPane.showMessageDialog(this,"Der lokale SSONET Port darf nicht gleich null sein","Unlogische Eingabe", JOptionPane.ERROR_MESSAGE);
	    return false;
	}
	if (rrPort==0) {
	    JOptionPane.showMessageDialog(this,"Der Port des entfernten Rechners darf nicht gleich null sein","Unlogische Eingabe", JOptionPane.ERROR_MESSAGE);
	    return false;
	}
	if ((rrAd == null) || (rrAd.length()==0)) {
	    JOptionPane.showMessageDialog(this,"Bitte geben Sie die Adresse des entfernten Rechners ein","Fehlende Eingabe", JOptionPane.ERROR_MESSAGE);
	    return false;
	}

	return true;
    }

    public AbstractServer getConfig() {
	return clConf;
    }

    public void actionPerformed(ActionEvent e) {
	String s = e.getActionCommand();

	if (s == "Start SSONET Server") {
	    // zuerst die Daten ueberpruefen und setzen
	    if (checkdatas()) {
		status = true;  // mit start beendet
		clConf = new UniServer(lokPort, rrPort, rrAd);
		dispose();
	    }
	}
	if (s == "Abbruch") {
	    status = false;
	    dispose();
	}
	if (s == "Konfiguration") {
	    JOptionPane.showMessageDialog(this,"Noch keine Konfiguration implementiert","Fehlender Programmcode", JOptionPane.ERROR_MESSAGE);
	}
    }

}
