/*
 * experimental source code
 * sproxy/client/UniClient.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package sproxy.client;

/**
* stellt einen universellen Client dar
*/
public class UniClient extends AbstractClient {

    // Speicherung der Ports und der ServerAdresse
    protected int listenport, sendingport;
    protected String serveradress;
    protected String appname;
    protected int ID;

    public UniClient(int listenport, int sentport, String serveradress, String appname, int ID) {
	this.listenport   = listenport;
	this.sendingport  = sentport;
	this.serveradress = new String(serveradress);
	this.appname      = new String(appname);
	this.ID           = ID;
    }

    /**
    * liefert den Port, auf dem gelauscht werden soll
    */
    public int getlisteningPort() {
	return listenport;
    }

    /**
    * liefert den Port, auf dem der SSONETServer lauscht
    */
    public int getSSONETPort() {
	return sendingport;
    }

    /**
    * liefert die Adresse des SSONETServers
    */
    public String getSSONETServer() {
	return new String(serveradress);
    }

    /**
    * liefert den Applikationsnamen, hier eindeutig "test"
    */
    public String getAppName() {
	return new String(appname);
    }

    /**
    * liefert die ID
    */
    public int getID() {
	return ID;
    }
}
