/*
 * catalog/customer/Catalog.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package catalog.customer;

/**
* creates a catalog
*/

public class Catalog {

    public int numberOfRows;
    public String Title, Info, Host, Currency;
    public int Tax, Port;
    public String[] temp;

    /**
    * set Catalog Title to string
    */
    public void setTitle(String string) {
        Title = new String(string);
    }

    /**
    * set Catalog Info to string
    */
    public void setInfo(String string) {
        Info = new String(string);
    }

    /**
    * set Catalog Host to string
    */
    public void setHost(String str) {
        Host = new String(str);
    }

    /**
    * set Catalog Port to string
    */
    public void setPort(String string) {
        try {
            Port = (new Integer(string)).intValue();
        } catch (Exception e) {
            System.out.println("Fehler in Catalog.setPort:" + e);
            Port = 2000;
        }
    }

    /**
    * set Catalog Currency to string
    */
    public void setCurrency(String string) {
        Currency = new String(string);
    }

    /**
    * Changes string into a number<br>
    * in case of an error into 16
    */
    public void setTax(String taxRate) {
        try {
            Tax = (new Integer(taxRate)).intValue();
        } catch (Exception e) {
            System.out.println("Fehler in Catalog.setTax:" + e);
            Tax = 16;
        }
    }

    /**
    * initialize the catalog stringarray to number rows
    */
    public void initTemp(int number) {
        numberOfRows = number;
        temp = new String[numberOfRows];
        System.out.println("Anzahl der Katalogeintragung = " + numberOfRows);
    }

    /**
    * set catalog row i to string
    */
    public void setTemp(int i, String string) {
        temp[i] = new String(string);
    }


    /**
    * shows the complete catalog
    */
    public String toString() {
        StringBuffer stringBuffer = new StringBuffer();
        stringBuffer.append("Title:" + Title + "\n" +
	    "Info:" + Info + "\n" +
	    "Currency:" + Currency + "\n" +
	    "Tax:" + Tax + "%\n");
        for (int i = 0; i < numberOfRows; i++)
            stringBuffer.append("Entry (" + i + "):" + temp[i] + "\n" +
	    ">>>>>End (Entries = " + numberOfRows + ") <<<<<<" + "\n");
        return stringBuffer.toString();
    }
}
