/*
 * catalog/net/CatalogFile.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package catalog.net;

import java.io.*;

/**
* a file which contains a catalog
*/
public class CatalogFile implements Serializable {
    public byte allBytes[];
    public int numberOfBytes;
    public File file;
    private long fileLength;

    public CatalogFile() {
        allBytes = null;
        file = null;
    }

    /**
    * creates a file which contains a catalog
    */
    public CatalogFile(File file) {
        this.file = file;
        RandomAccessFile randomAccessFile;
        try {
            if (!file.canRead()) {
                System.out.println("Cant read " + file.getName());
                return;
            }
            randomAccessFile = new RandomAccessFile(file,"r");
            fileLength = randomAccessFile.length();
            numberOfBytes = (new Long(fileLength)).intValue();
            allBytes = new byte[numberOfBytes];
            randomAccessFile.readFully(allBytes);
            randomAccessFile.close();
        }
        catch (Exception e) {
            System.out.println("Error in CatalogFile" + e);
            allBytes = null;
            file = null;
        }
    }
}
