/*
 * catalog/net/Connection.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package catalog.net;

import catalog.merchant.Merchant;
import catalog.merchant.MerchantServer;

import java.io.*;
import java.net.*;
import java.util.*;

import smi.io.IOStream;

import ssonet.SSONETStream;

/**
* Connection of a MerchantServer
*/
public class Connection extends Thread {
    private MerchantServer merchantServer;
    private SSONETStream ssonetStream;

    /**
    * creates a connection of a MerchantServer
    */
    public Connection(ThreadGroup threadGroup, SSONETStream ssonetStream, MerchantServer merchantServer) {
        super(threadGroup,"Connection");
	this.ssonetStream = ssonetStream;
	this.merchantServer = merchantServer;
	setDaemon(true);
	start();
    }

    /**
    * read requests from Client
    */
    public void run() {
	try {
	    System.out.println(Integer.toString(ssonetStream.getID()));
	    if(ssonetStream.getID() == Merchant.CATALOG) {
		System.out.println("Catalog request.");
		ssonetStream.writeObject(merchantServer.requestCatalog());
	    } else {
		Object object = ssonetStream.readObject();
		System.out.println("Object of Class:" + object.getClass().getName());
		if (object instanceof Order)
		    ssonetStream.writeObject(merchantServer.getOrder((Order)object));
		else
		    ssonetStream.writeObject(new Integer(-1));
            }
	    ssonetStream.close();
	} catch (Exception e) {
	    System.err.println("Error Connection.run(): " + e);
	    e.printStackTrace();
	}
    }
}
