/*
 * goals/Goals.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package goals;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import help.Help;
import goals.awt.CommunicationSecurityDialog;

public class Goals extends JFrame implements ActionListener {
    public JFrame frame;
    private static Help help;   // static, because only one Help should exist

    public Goals () {
        help = new Help("file:///"+System.getProperty("ssonet_help")+"goals/HelpSet.hs");
        setTitle("Sample Application");
        getContentPane().setLayout(new BorderLayout());
        JLabel label = new JLabel("sample application");
        label.setHorizontalAlignment(SwingConstants.CENTER);
        getContentPane().add(label, BorderLayout.CENTER);
        getContentPane().add(label);
        setSize(400,250);

        JMenuBar menu = new JMenuBar();
        JMenu securityMenu = new JMenu("Einstellungen");
        securityMenu.setMnemonic('e');
        menu.add (securityMenu);

        JMenuItem communicationMenuItem = new JMenuItem("Kommunikation...");
        communicationMenuItem.setMnemonic('k');
        communicationMenuItem.addActionListener(this);
        securityMenu.add(communicationMenuItem);

        JMenuItem localDataMenuItem = new JMenuItem("lokale Daten...");
        localDataMenuItem.setMnemonic('o');
        localDataMenuItem.setEnabled(false);
        securityMenu.add(localDataMenuItem);

        JMenuItem managementMenuItem = new JMenuItem("Management...");
        managementMenuItem.setMnemonic('o');
        managementMenuItem.setEnabled(false);
        securityMenu.add(managementMenuItem);

        setJMenuBar (menu);

	addWindowListener(new WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent event) {
                System.exit(0);
            }
        });

        show();
    }

    public static void main(String[] argv) {
        Goals sampleApplication = new Goals();
    }

    public void actionPerformed (ActionEvent ae) {

        CommunicationSecurityDialog dialog = new CommunicationSecurityDialog(this, help);
        dialog.show();
    }
}
