/*
 * smi/awt/AppletFrame.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package smi.awt;

import java.awt.AWTEvent;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;

final public class AppletFrame extends JFrame {
    private boolean bExit = true;

    public AppletFrame() {
	this("Untitled");
    }

    public AppletFrame(String str) {
	super (str);
	enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    }

    public AppletFrame(String str, boolean bExit) {
	super (str);
	this.bExit = bExit;
	enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    }

    public void center() {
	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	Dimension ownDimension = getSize();
	setLocation((screenSize.width - ownDimension.width) / 2,
	    (screenSize.height - ownDimension.height) / 2);
    }

    public void processWindowEvent(WindowEvent e) {
	switch (e.getID()) {
	case WindowEvent.WINDOW_CLOSING:
	    dispose();
	    if (bExit) System.exit(0);
	    break;
	default:
	    super.processWindowEvent(e);
	    break;
	}
    }
}
