/*
 * smi/awt/SpinnerButton.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package smi.awt;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Toolkit;


import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import java.awt.AWTEvent;
import java.awt.AWTEventMulticaster;

public class SpinnerButton extends Component {
    private static byte rawDataUnpressed[] = {
	0x47,(byte)0x49,(byte)0x46,(byte)0x38,(byte)0x39,(byte)0x61,(byte)0x12,(byte)0x00,(byte)0x12,(byte)0x00,(byte)0xB3,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)
	0x80,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x80,(byte)0x00,(byte)0x80,(byte)0x80,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x80,(byte)0x80,(byte)0x00,(byte)0x80,(byte)0x00,(byte)
	0x80,(byte)0x80,(byte)0xC0,(byte)0xC0,(byte)0xC0,(byte)0x80,(byte)0x80,(byte)0x80,(byte)0xFF,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0xFF,(byte)0x00,(byte)0xFF,(byte)0xFF,(byte)
	0x00,(byte)0x00,(byte)0x00,(byte)0xFF,(byte)0xFF,(byte)0x00,(byte)0xFF,(byte)0x00,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0x2C,(byte)0x00,(byte)0x00,(byte)
	0x00,(byte)0x00,(byte)0x12,(byte)0x00,(byte)0x12,(byte)0x00,(byte)0x00,(byte)0x04,(byte)0x4A,(byte)0xF0,(byte)0xC9,(byte)0x49,(byte)0xAB,(byte)0x44,(byte)0xEF,(byte)0xE8,(byte)
	0xCD,(byte)0x3B,(byte)0x02,(byte)0xD9,(byte)0x06,(byte)0x74,(byte)0x1B,(byte)0x72,(byte)0x7C,(byte)0xE1,(byte)0x01,(byte)0xAC,(byte)0x24,(byte)0x76,(byte)0x82,(byte)0xDA,(byte)
	0x2A,(byte)0x73,(byte)0xEE,(byte)0x9B,(byte)0xC9,(byte)0xB8,(byte)0x56,(byte)0xDB,(byte)0x64,(byte)0x99,(byte)0xF2,(byte)0xBD,(byte)0x9D,(byte)0x0E,(byte)0xD6,(byte)0xFA,(byte)
	0x0D,(byte)0x8D,(byte)0x27,(byte)0x24,(byte)0xD0,(byte)0xD7,(byte)0x5B,(byte)0x26,(byte)0x55,(byte)0x38,(byte)0x16,(byte)0x8A,(byte)0x19,(byte)0xCB,(byte)0x01,(byte)0x85,(byte)
	0xD0,(byte)0xD1,(byte)0xF1,(byte)0x49,(byte)0xD2,(byte)0x6E,(byte)0x9B,(byte)0x2D,(byte)0x10,(byte)0x62,(byte)0x4C,(byte)0x2E,(byte)0x9B,(byte)0x3F,(byte)0x9F,(byte)0xA8,(byte)
	0x3A,(byte)0x1A,(byte)0x01,(byte)0x00,(byte)0x3B
    };

    private static Image imageUnpressed=Toolkit.getDefaultToolkit().createImage(rawDataUnpressed);

    private static byte rawDataDown[] ={
	0x47,(byte)0x49,(byte)0x46,(byte)0x38,(byte)0x39,(byte)0x61,(byte)0x12,(byte)0x00,(byte)0x12,(byte)0x00,(byte)0xB3,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)
	0x80,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x80,(byte)0x00,(byte)0x80,(byte)0x80,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x80,(byte)0x80,(byte)0x00,(byte)0x80,(byte)0x00,(byte)
	0x80,(byte)0x80,(byte)0xC0,(byte)0xC0,(byte)0xC0,(byte)0x80,(byte)0x80,(byte)0x80,(byte)0xFF,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0xFF,(byte)0x00,(byte)0xFF,(byte)0xFF,(byte)
	0x00,(byte)0x00,(byte)0x00,(byte)0xFF,(byte)0xFF,(byte)0x00,(byte)0xFF,(byte)0x00,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0x2C,(byte)0x00,(byte)0x00,(byte)
	0x00,(byte)0x00,(byte)0x12,(byte)0x00,(byte)0x12,(byte)0x00,(byte)0x00,(byte)0x04,(byte)0x4B,(byte)0xF0,(byte)0xC9,(byte)0x49,(byte)0xEB,(byte)0x43,(byte)0xE8,(byte)0x9D,(byte)
	0xCD,(byte)0x7B,(byte)0x47,(byte)0xC0,(byte)0xA1,(byte)0x71,(byte)0xA1,(byte)0xB7,(byte)0x81,(byte)0xD9,(byte)0x78,(byte)0x00,(byte)0xAC,(byte)0x89,(byte)0xA6,(byte)0x1B,(byte)
	0x2B,(byte)0x7F,(byte)0x00,(byte)0x26,(byte)0x6A,(byte)0x72,(byte)0x7E,(byte)0xD6,(byte)0xC8,(byte)0x26,(byte)0x99,(byte)0x9C,(byte)0x17,(byte)0xE7,(byte)0x07,(byte)0x14,(byte)
	0x0E,(byte)0x55,(byte)0x34,(byte)0x5B,(byte)0x87,(byte)0x98,(byte)0xEC,(byte)0x79,(byte)0x98,(byte)0x3B,(byte)0xE5,(byte)0x13,(byte)0x69,(byte)0x34,(byte)0x31,(byte)0x85,(byte)
	0xB9,(byte)0x19,(byte)0xB1,(byte)0x9A,(byte)0xF5,(byte)0x69,(byte)0xAA,(byte)0xB1,(byte)0x96,(byte)0x17,(byte)0x4C,(byte)0x5A,(byte)0x92,(byte)0x81,(byte)0xA2,(byte)0x9E,(byte)
	0x65,(byte)0x3D,(byte)0x89,(byte)0x00,(byte)0x00,(byte)0x3B
    };

    private static Image imageDown=Toolkit.getDefaultToolkit().createImage(rawDataDown);

    private static byte rawDataUp[] ={
	0x47,(byte)0x49,(byte)0x46,(byte)0x38,(byte)0x39,(byte)0x61,(byte)0x12,(byte)0x00,(byte)0x12,(byte)0x00,(byte)0xB3,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)
	0x80,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x80,(byte)0x00,(byte)0x80,(byte)0x80,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x80,(byte)0x80,(byte)0x00,(byte)0x80,(byte)0x00,(byte)
	0x80,(byte)0x80,(byte)0xC0,(byte)0xC0,(byte)0xC0,(byte)0x80,(byte)0x80,(byte)0x80,(byte)0xFF,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0xFF,(byte)0x00,(byte)0xFF,(byte)0xFF,(byte)
	0x00,(byte)0x00,(byte)0x00,(byte)0xFF,(byte)0xFF,(byte)0x00,(byte)0xFF,(byte)0x00,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0xFF,(byte)0x2C,(byte)0x00,(byte)0x00,(byte)
	0x00,(byte)0x00,(byte)0x12,(byte)0x00,(byte)0x12,(byte)0x00,(byte)0x00,(byte)0x04,(byte)0x4D,(byte)0x10,(byte)0xC8,(byte)0x49,(byte)0x2B,(byte)0x7A,(byte)0x12,(byte)0xE9,(byte)
	0xCD,(byte)0xF9,(byte)0x3B,(byte)0xD9,(byte)0x21,(byte)0x8E,(byte)0xA4,(byte)0xF8,(byte)0x3C,(byte)0x48,(byte)0x38,(byte)0x02,(byte)0xE5,(byte)0x71,(byte)0x1E,(byte)0x29,(byte)
	0x80,(byte)0xAC,(byte)0x12,(byte)0xF9,(byte)0xC2,(byte)0x6A,(byte)0x65,(byte)0x7E,(byte)0x62,(byte)0x3C,(byte)0x57,(byte)0x92,(byte)0x5B,(byte)0x4F,(byte)0x55,(byte)0x12,(byte)
	0x0E,(byte)0x65,(byte)0x2D,(byte)0xE3,(byte)0x71,(byte)0x66,(byte)0xE3,(byte)0x95,(byte)0x7C,(byte)0xCD,(byte)0xD6,(byte)0x72,(byte)0xF4,(byte)0x02,(byte)0xB2,(byte)0xA0,(byte)
	0x2E,(byte)0xA7,(byte)0x0E,(byte)0x87,(byte)0x54,(byte)0x4E,(byte)0x46,(byte)0x3E,(byte)0xA5,(byte)0x88,(byte)0x05,(byte)0x96,(byte)0x89,(byte)0xA5,(byte)0xA9,(byte)0x4F,(byte)
	0x67,(byte)0xCD,(byte)0xB1,(byte)0xBA,(byte)0x29,(byte)0x11,(byte)0x00,(byte)0x3B
    };
    private static Image imageUp=Toolkit.getDefaultToolkit().createImage(rawDataUp);

    private byte state=0;

    private static byte DOWN=1;
    private static byte UP=2;
    ActionListener actionListener;     // Post action events to listeners

    public SpinnerButton() {
	enableEvents(AWTEvent.MOUSE_EVENT_MASK);
    }

    /**
    * Adds the specified action listener to receive action events
    * from this button.
    * @param listener the action listener
    */
    public void addActionListener(ActionListener listener) {
	actionListener = AWTEventMulticaster.add(actionListener, listener);
	enableEvents(AWTEvent.MOUSE_EVENT_MASK);
    }

    /**
    * Removes the specified action listener so it no longer receives
    * action events from this button.
    * @param listener the action listener
    */
    public void removeActionListener(ActionListener listener) {
	actionListener = AWTEventMulticaster.remove(actionListener, listener);
    }
    public Dimension getMaximumSize() {
	return new Dimension(18,18);
    }
    public Dimension getMinimumSize() {
	return new Dimension(18,18);
    }
    public Dimension getPreferredSize() {
	return new Dimension(18,18);
    }

    public void update(Graphics g) {
	paint(g);
    }

    public void paint(Graphics g) {
	if(state==DOWN)
	    g.drawImage(imageDown,0,0, this);
	else if(state==UP)
	    g.drawImage(imageUp,0,0, this);
	else
	    g.drawImage(imageUnpressed,0,0, this);
    }

    /**
    * Determine if click was inside round button.
    */
    public boolean contains(int x, int y) {
	return (x<18)&&(y<18)&&(x>=0)&&(y>=0);
    }

    /**
    * Paints the button and distribute an action event to all listeners.
    */
    public void processMouseEvent(MouseEvent e) {
	switch(e.getID()) {
	case MouseEvent.MOUSE_PRESSED:
	    // render myself inverted....
	    if(e.getX()+e.getY()<18)
		state=UP;
	    else
		state=DOWN;
	    if(actionListener != null) {
		if(state==UP)
		    actionListener.actionPerformed(new ActionEvent(
		    this, ActionEvent.ACTION_PERFORMED, "UP"));
		else
		    actionListener.actionPerformed(new ActionEvent(
		    this, ActionEvent.ACTION_PERFORMED, "DOWN"));
	    }            // Repaint might flicker a bit. To avoid this, you can use
	    // double buffering (see the Gauge example).
	    repaint();
	    break;
	case MouseEvent.MOUSE_RELEASED:

	    // render myself normal again
	    if(state != 0) {
		state = 0;

		// Repaint might flicker a bit. To avoid this, you can use
		// double buffering (see the Gauge example).
		repaint();
	    }
	    break;
	case MouseEvent.MOUSE_ENTERED:
	    break;
	case MouseEvent.MOUSE_EXITED:
	    if(state != 0) {
		// Cancel! Don't send action event.
		state = 0;

		// Repaint might flicker a bit. To avoid this, you can use
		// double buffering (see the Gauge example).
		repaint();

		// Note: for a more complete button implementation,
		// you wouldn't want to cancel at this point, but
		// rather detect when the mouse re-entered, and
		// re-highlight the button. There are a few state
		// issues that that you need to handle, which we leave
		// this an an excercise for the reader (I always
		// wanted to say that!)
	    }
	    break;
	}
	super.processMouseEvent(e);
    }
}
