/*
 * smi/baseConf/NewCertificateDialog.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package smi.baseConf;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Insets;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JPanel;

import sun.security.x509.X509Cert;
import smi.baseConf.BaseConfiguration;

public class NewCertificateDialog implements ActionListener {
    private static JButton okButton;
    private static JButton cancelButton;
    private static JTextField textField;
    private static String duration;
    JDialog dialog;

    public NewCertificateDialog(JFrame parentFrame) {
	try {
	    GridBagLayout gridBagLayout = new GridBagLayout();
	    GridBagConstraints gridBagConstraints = new GridBagConstraints();
	    gridBagConstraints.fill = GridBagConstraints.BOTH;
	    gridBagConstraints.insets = new Insets(10,10,10,10);

	    dialog = new JDialog(parentFrame, BaseConfiguration.getLangResources().getString("CERTIFICATE OPTIONS"), true);
	    Container contentPane = dialog.getContentPane();
	    contentPane.setLayout(gridBagLayout);

	    JLabel durationLabel = new JLabel(BaseConfiguration.getLangResources().getString("VALIDITY RANGE IN DAYS"), JLabel.LEFT);
	    gridBagConstraints.gridx=0;
	    gridBagConstraints.gridy=0;
	    gridBagConstraints.gridwidth=1;
	    gridBagConstraints.gridheight=1;
	    gridBagLayout.setConstraints(durationLabel, gridBagConstraints);
	    contentPane.add(durationLabel);

	    textField = new JTextField("365");
	    gridBagConstraints.gridx=1;
	    gridBagConstraints.gridy=0;
	    gridBagConstraints.gridwidth=1;
	    gridBagConstraints.gridheight=1;
	    gridBagLayout.setConstraints(textField, gridBagConstraints);
	    contentPane.add(textField);

	    JPanel okcancelPanel = new JPanel();
	    okButton = new JButton(BaseConfiguration.getLangResources().getString("OK"));
	    okButton.addActionListener(this);
	    okcancelPanel.add(okButton);

	    cancelButton = new JButton(BaseConfiguration.getLangResources().getString("CANCEL"));
	    cancelButton.addActionListener(this);
	    okcancelPanel.add(cancelButton);

	    gridBagConstraints.gridx=0;
	    gridBagConstraints.gridy=1;
	    gridBagConstraints.gridwidth=2;
	    gridBagConstraints.gridheight=1;
	    gridBagLayout.setConstraints(okcancelPanel, gridBagConstraints);
	    contentPane.add(okcancelPanel);

	    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	    Dimension ownDimension = dialog.getSize();
	    dialog.setLocation((screenSize.width - ownDimension.width) / 2,
		(screenSize.height - ownDimension.height) / 2);
	    dialog.pack();
	    dialog.setResizable(false);
	    dialog.show();
	} catch(Exception e) {
	    e.printStackTrace();
	}
    }

    public static String getAnswer(JFrame parentFrame) {
	NewCertificateDialog newCertificateDialog = new NewCertificateDialog(parentFrame);
	return duration;
    }

    public void actionPerformed (ActionEvent event) {
	if (event.getSource() == okButton) {
	    duration=textField.getText();
	    dialog.dispose();
	} else if (event.getSource() == cancelButton) {
	    duration=null;
	    dialog.dispose();
	}
    }
}
