/*
 * smi/baseConf/locale/Resources_de.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package smi.baseConf.locale;

import java.util.ListResourceBundle;

public class Resources_de extends ListResourceBundle {
    public Object[][] getContents() {
	return contents;
    }

    static final Object[][] contents = {
	// Buttons...
	{"YES","Ja"},
	{"NO","Nein"},
	{"OK","Ok"},
	{"CANCEL","Abbrechen"},
	{"ABORT","Abbrechen"},
	{"RETRY","Wiederholen"},
	{"DETAIL","Konfiguration ndern"},
	{"WARNING","Achtung"},
	{"MESSAGE","Hinweis"},

	// Menu...
	{"BASE CONFIGURATION","Grundkonfiguration"},
	{"SETTINGS","Einstellungen"},
	{"KEYEXCHANGE","Schlsselaustausch"},
	{"TEST_CERTIFICATES","teste Zertifikate"},
	{"NEW_CIPHERKEY","neues Chiffrierschlsselpaar"},
	{"NEW_CERTIFICATE","Chiffrierschlsselzertifikat zu Schlsselpaar"},
	{"INFO","Info"},
	{"KEYS","Schlssel"},
	{"LANGUAGE","Sprache"},
	{"HELP","Hilfe"},
	{"GERMAN","Deutsch"},
	{"ENGLISH","Englisch"},
	{"PERFORMANCE_TEST","Geschwindigkeitstest"},
	{"RATING","Bewertung"},
	{"PROVIDER","Provider"},
	{"ASYMMETRIC_MECHANISMS","Asymmetrische Mechanismen"},
	{"DSA","DSA"},
	{"ELGAMAL","ElGamal"},
	{"RSA","RSA"},
	{"NEW_DSA_KEY","DSA"},
	{"NEW_RSA_KEY","RSA"},
	{"NEW_ELGAMAL_KEY","ElGamal"},
	{"NEW_DSA_CERTIFICATE","DSA Schlssel"},
	{"NEW_RSA_CERTIFICATE","RSA Schlssel"},
	{"NEW_ELGAMAL_CERTIFICATE","ElGamal Schlssel"},
	{"NEW_MECHANISM_KEY","Neuer Schlssel fr"},
	{"NEW_MECHANISM_CERTIFICATE","Neues Zertifikat fr"},

	// Tab Header...
	{"CONFIDENTIALITY","Vertraulichkeit"},
	{"ANONYMITY", "Anonymitt"},
	{"INTEGRITY","Integritt"},
	{"ACCOUNTABILITY","Zurechenbarkeit"},

	// Titles
	{"CHIPHER_MESSAGES","Verschlsseln von Nachrichten"},
	{"PREFERENCELIST","Prferenzliste"},
	{"AVAILABLE_MECHANISMS","Verfgbare Mechanismen"},
	{"CHOSEN_ROUTE","Gewhlte Route"},
	{"AVAILABLE_MIXES","Verfgbare Mixe"},
	{"USEAGE_OF_MIXES","Verwenden einer MIX-Kette"},
	{"USE_AUTHENTICATION","Verwenden von symmetrischen Authentikationsmechanismen"},
	{"CREATE_SIGNATURES","Signaturen erstellen"},
	{"ACCEPT_SIGNATURES","Signaturen anerkennen"},
	{"CATEGORIE","Kategorie"},
	{"ASK_BEFORE_SIGN","Abfrage bevor eine digitale Signatur erstellt wird"},

	// Detail configuration
	{"DETAIL CONFIGURATION","Detailkonfiguration"},
	{"MODE","Modus"},
	{"KEY","Schlssel"},
	{"ROUNDS","Rundenzahl"},
	{"PREFERENCE LIST","Prferenzliste"},
	{"AVAILABLE MODES","verfgbare Modi"},
	{"AVAILABLE VARIANTS","verfgbare Varianten"},
	{"MINIMAL KEY LENGTH","minimale Schlssellnge (bit):"},
	{"NUMBER OF MINIMUM ROUNDS","Mindestanzahl von Runden:"},
	{"VARIANTS","Varianten"},
	{"CERTIFICATE","Zertifikat"},
	{"THIS CERTIFICATE IS VALID TO","Das Zertifikat ist gltig bis:"},
	{"REFRESH CERTIFICATE","Erneuern des Zertifikates"},
	{"REFRESH KEY","Erneuern des Schlssels"},
	{"NO CERTIFICATE PRESENT","    Kein Zertifikat vorhanden!   "},
	{"PLEASE CREATE A CERTIFICATE","Bitte erzeugen Sie ein Zertifikat!"},

	//Certificate
	{"CERTIFICATE OPTIONS","Zertifikateinstellung"},
	{"VALIDITY RANGE IN DAYS","Gltigkeit in Tagen"},
	{"INVALID KEY MESSAGE","Eines oder mehrere der getesteten Zertifikate sind ungltig."},
	{"VALID KEY MESSAGE","Alle Schlssel und deren Zertifikate sind gltig."},
	{"CREATE KEY MESSAGE","Schlsselgenerierung erfolgreich. Ihr neues Schlsselpaar befindet sich in\nkeys/KeyExchangeRSAPrivateKey.object und\nkeys/KeyExchangeRSAPublicKey.object"},
	{"CREATE CERTIFICATE MESSAGE","Zertifikat erfolgreich erstellt.\nkeys/KeyExchangeRSACertificate.der wurde erstellt."},
	{"NO KEY PAIR","Es wird ein Schlsselpaar bentigt.\nStarten sie bitte erst die Schlsselgenerierung."},

	//Rating
	{"RATING","Bewertung"},
	{"SECURITY OF THE ALGORITHM","Sicherheit des Algorithmus: Bewertung "},
	{"RATINGTOOLTIP1","Hier stellen Sie den Wert der Sicherheit des Algorithmus ein."},
	{"SECURITY OF THE IMPLEMENTATION","Sicherheit der Implementation: Bewertung "},
	{"RATINGTOOLTIP2","Hier stellen Sie den Wert der Sicherheit der Implementation ein."},
	{"PERFORMANCE","Geschwindigkeit: Bewertung "},
	{"RATINGTOOLTIP3","Hier stellen Sie den Wert der Geschwindigkeit ein."},
	{"MINIMUM ALGORITHM THROUGHPUT","Min. Durchsatz des Algorithmus: Bewertung "},
	{"RATINGTOOLTIP4","Hier stellen Sie den Wert des minimalen Durchsatzes ein."},
	{"LOW COSTS","Geringe Kosten: Bewertung "},
	{"RATINGTOOLTIP5","Hier stellen Sie den Wert der minimalen Kosten ein."},
	{"MAXIMUM COSTS","Maximalkosten: Bewertung "},
	{"RATINGTOOLTIP6","Hier stellen Sie den Wert der Maximalkosten ein..."},
	{"CHALLANGES","Challenges: Rating "},
	{"RATINGTOOLTIP7","This determines the importance of processed challenges."},
	{"PERFORMANCETEST","Geschwindigkeitstest"},
	{"RATINGTOOLTIP8","Bestimmt die Geschwindigkeiten der installierten Algoritmen"},
	{"RATINGTOOLTIP9","Bewertung fr Vertraulichkeit"},
	{"RATINGTOOLTIP10","Bewertung fr Integritt"},
	{"RATINGTOOLTIP11","Bewertung fr Zurechenbarkeit"},
	{"RATINGTOOLTIP12","Bewertung fr Anonymitt"},
	{"TOO SLOW"," (zu langsam)"},
	{"TOO EXPENSIVE"," (zu teuer)"},
	{"TOO SLOW&EXPENSIVE"," (zu langsam & zu teuer)"},
	{"FILES MISSING","Es fehlen einige Dateien.\nBitte den Geschwindigkeitstest wiederholen."},
    };
}
