/*
 * smi/io/ObjectIOStream.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package smi.io;

import smi.io.IOStream;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.InputStream;
import java.io.OutputStream;

public class ObjectIOStream implements IOStream {
    ObjectInputStream objectInputStream;
    ObjectOutputStream objectOutputStream;

    public ObjectIOStream(InputStream inputStream, OutputStream outputStream) {
	try {
	    if(outputStream != null)
		objectOutputStream = new ObjectOutputStream(outputStream);
	    if(inputStream != null)
		objectInputStream = new ObjectInputStream(inputStream);
	} catch(Exception e) {
	    System.out.println("Error in ObjectIOStream.ObjectIOStream");
	    e.printStackTrace();
	}
    }

    public Object readObject() throws Exception {
	try {
	    return objectInputStream.readObject();
	} catch(Exception e) {
	    throw e;
	}
    }

    public void writeObject(Object o) throws Exception {
	try {
	    objectOutputStream.writeObject(o);
	} catch(Exception e) {
	    throw e;
	}
    }

    public void close() {
	try {
	    objectInputStream.close();
	    objectOutputStream.close();
	} catch(Exception e) {
	    System.out.println("Exception in smi.io.ObjectIOStream.close"+e);
	}
    }

    public int available() {
	try {
	    return objectInputStream.available();
	} catch(Exception e) {
	    System.out.println("Exception in smi.io.ObjectIOStream.available"+e);
	    return 0;
	}
    }
}
