/*
 * smi/mechanisms/confidentiality/CAST5.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package smi.mechanisms.confidentiality;

import javax.swing.JFrame;

import smi.mechanisms.AbstractConfidentialityMechanism;
import smi.mechanisms.DetailConfigurationDialog;
import smi.mechanisms.MechanismConfiguration;

import ssonet.SSONETConstants;

public class CAST5 extends AbstractConfidentialityMechanism {
    public CAST5() {
    }

    public MechanismConfiguration getDefaultConfiguration() {
	MechanismConfiguration  defaultConfiguration = new MechanismConfiguration();
	String defaultMode[] = {"OFB"};
	String defaultProvider[] = {"Cryptix"};
	defaultConfiguration.put(PROVIDERLIST, defaultProvider);
	defaultConfiguration.put(KEY_MODE_PREFERENCELIST, defaultMode);
	defaultConfiguration.put(KEY_KEYLENGTH, new Integer(80));
	return defaultConfiguration;
    }

    public MechanismConfiguration configDetail(JFrame parentFrame, MechanismConfiguration actualConfiguration) {
	DetailConfigurationDialog detailConfigurationDialog = new DetailConfigurationDialog(parentFrame, getClass().getName());

	if(actualConfiguration == null) actualConfiguration = getDefaultConfiguration();

	//Provider
	detailConfigurationDialog.addTabProvider((String [])actualConfiguration.get(PROVIDERLIST));

	//Modes
	detailConfigurationDialog.addTabMode((String [])actualConfiguration.get(KEY_MODE_PREFERENCELIST),
	    SSONETConstants.CONFIDENTIALITY);

	// key length
	Integer actualKeyLength = (Integer)actualConfiguration.get(KEY_KEYLENGTH);
	if (actualKeyLength == null) actualKeyLength = new Integer(80);
	detailConfigurationDialog.addTabKey(40,128,8, actualKeyLength.intValue());

	detailConfigurationDialog.pack();
	detailConfigurationDialog.setResizable(false);
	detailConfigurationDialog.setLocationRelativeTo(parentFrame);
	detailConfigurationDialog.setVisible(true);
	if(detailConfigurationDialog.getReturnCode()) {
	    actualConfiguration.put(PROVIDERLIST, detailConfigurationDialog.getProviderPreferenceList());
	    actualConfiguration.put(KEY_MODE_PREFERENCELIST, detailConfigurationDialog.getModePreferenceList());
	    actualConfiguration.put(KEY_KEYLENGTH, new Integer(detailConfigurationDialog.getKeyLength()));
	}
	return actualConfiguration;
    }
}
