/*
 * smi/mechanisms/integrity/SPEED.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package smi.mechanisms.integrity;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import smi.mechanisms.AbstractIntegrityMechanism;
import smi.mechanisms.DetailConfigurationDialog;
import smi.mechanisms.MechanismConfiguration;
import smi.baseConf.BaseConfiguration;

import ssonet.SSONETConstants;

public class SPEED extends AbstractIntegrityMechanism {

    private String ROUNDSTOOLTIP = "minimal: 32 -  save: 64";
    public SPEED() {
    }

    public MechanismConfiguration getDefaultConfiguration() {
	MechanismConfiguration  defaultConfiguration = new MechanismConfiguration();
	String[] defaultMode = {"OFB"};
	String defaultProvider[] = {"Cryptix"};
	defaultConfiguration.put(PROVIDERLIST, defaultProvider); defaultConfiguration.put(KEY_MODE_PREFERENCELIST, defaultMode);
	defaultConfiguration.put(KEY_MODE_PREFERENCELIST, defaultMode);
	defaultConfiguration.put(KEY_KEYLENGTH, new Integer(80));
	defaultConfiguration.put(KEY_ROUNDS, new Integer(64));
	return defaultConfiguration;
    }

    public MechanismConfiguration configDetail(JFrame parentFrame, MechanismConfiguration actualConfiguration) {
	DetailConfigurationDialog detailConfigurationDialog = new DetailConfigurationDialog(parentFrame, getClass().getName());

	if(actualConfiguration == null)
	    actualConfiguration = getDefaultConfiguration();

	// provider
	detailConfigurationDialog.addTabProvider((String [])actualConfiguration.get(PROVIDERLIST));

	// mode
	detailConfigurationDialog.addTabMode((String [])actualConfiguration.get(KEY_MODE_PREFERENCELIST),
	    SSONETConstants.INTEGRITY);

	// key
	Integer actualKeyLength = (Integer)actualConfiguration.get(KEY_KEYLENGTH);
	if (actualKeyLength == null)
	    actualKeyLength = new Integer(80);
	detailConfigurationDialog.addTabKey(48,256,16, actualKeyLength.intValue());

	// rounds
	Integer actualRounds = (Integer)actualConfiguration.get(KEY_ROUNDS);
	if (actualRounds == null)
	    actualRounds = new Integer(16);
	detailConfigurationDialog.addTab(BaseConfiguration.getLangResources().getString("ROUNDS"),
	    detailConfigurationDialog.roundsPanel(actualRounds.intValue(), ROUNDSTOOLTIP));

	detailConfigurationDialog.pack();
	detailConfigurationDialog.setResizable(false);
	detailConfigurationDialog.setLocationRelativeTo(parentFrame);
	detailConfigurationDialog.setVisible(true);
	if(detailConfigurationDialog.getReturnCode()) {
	    actualConfiguration.put(PROVIDERLIST, detailConfigurationDialog.getProviderPreferenceList());
	    actualConfiguration.put(KEY_MODE_PREFERENCELIST, detailConfigurationDialog.getModePreferenceList());
	    actualConfiguration.put(KEY_KEYLENGTH, new Integer(detailConfigurationDialog.getKeyLength()));
	    actualConfiguration.put(KEY_ROUNDS, new Integer(detailConfigurationDialog.getRounds()));
	}
	return actualConfiguration;
    }
}
