/*
 * experimental source code
 * sproxy/client/AbstractClient.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package sproxy.client;

/**
* implementiert einen Client insofern, das die Ports fuer die Anfragen und fuer die Verbindung zum SSONETServer dargestellt werden.
* Die Adresse des SSONETServers wird ebenfalls gespeichert.
*/
public abstract class AbstractClient {
    /**
    * liefert den Port zurueck, der auf dem lokalen Rechner belauscht werden soll
    */
    abstract int getlisteningPort();

    /**
    * liefert den Port zurueck, auf dem der SSONETServer laeuft
    */
    abstract int getSSONETPort();

    /**
    * liefert die Adresse des SSONETServers
    */
    abstract String getSSONETServer();

    /**
    * liefert den Namen der Applikation
    */
    abstract String getAppName();

    /**
    * liefert die ID
    */
    abstract int getID();

}
