/*
 * experimental source code
 * sproxy/server/ServerProxy.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package sproxy.server;
import  ssonet.*;
import  javax.swing.JFrame;
import  java.io.*;
import sproxy.awt.ServerConfigDialog;
import  smi.io.IOStream;

/**
* dieses ist die Hauptklasse. Von hier aus wird das Programm gestartet
*/
public class ServerProxy extends Thread {

    public static void main(String args[]) {

	AbstractServer as;

	ServerConfigDialog dlg = new ServerConfigDialog();
	if (dlg.status == false) System.exit(0);

	as = dlg.getConfig();
	// starten wir den ServerProxy mit der Richtigen Konfiguration
	new ServerProxy(as,"test", new JFrame());
    }

    protected SSONETServerConnection server_listener;
    protected int sendport; // zur uebergabe an den Thread
    protected AbstractServer df;

    /**
    * AbstractServer w beinhaltet die Informationen ueber die Ports, name ist der Applikationsname und mutter ist der Frame, der bei Ausgaben blockiert werden soll
    */
    public ServerProxy(AbstractServer w, String name, JFrame mutter) {
	df = w;
	sendport = w.getsendingPort();
	// zuerst die SSONETServerConnection
	try {
	    System.out.println("Starte SSONETServer mit folgender Konfiguration: ");
	    System.out.println("Applikationsname: "+name);
	    System.out.println("belauschter Port: "+w.getlisteningPort());
	    System.out.println("Dienst  : "+w.getsendingPort());
	    server_listener = new SSONETServerConnection(name, mutter, w.getlisteningPort());
	} catch (Exception e) {
	    System.out.println("Fehler beim Starten des SSONETServers: "+e);
	    System.exit(0);
	}
	System.out.println("SSONETServer steht bereit, wartet auf eingehende Verbindungen auf Port "+w.getlisteningPort());
	this.start();
    }

    public void run() {
	try {
	    while (true) {
		IOStream qw = server_listener.accept();
		System.out.println("Verbindungswunsch erhalten !");
		System.out.println("Starte Verbindung !");
		System.out.println("Sendport: "+sendport);
		new ServerProxyConnection(qw, sendport, df);
		System.out.println("Verbindung erzeugt, fange wieder an zu warten");
	    }
	} catch (IOException w) {
	    System.out.println("Fehler beim Aufbau der Verbindung: Konfiguration nicht gefunden !");
	    System.out.println("Verbindung wird NICHT aufgebaut");
	    this.stop();
	} catch (Exception e) {
	    System.out.println("Fehler beim Warten auf Verbindungswuensche: "+e);
	    System.exit(0);
	}
    }
}
