/*
 * ssonet/ConflictDialog.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package ssonet;

import java.awt.Color;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import smi.appConf.ActionConfiguration;
import smi.baseConf.BaseConfiguration;

public class ConflictDialog implements ActionListener {
    private JButton okButton = new JButton(" Yes ");
    private JButton cancelButton = new JButton("No");
    private boolean returnCode;
    private JFrame parentFrame;
    JDialog dialog;

    public ConflictDialog(String securityGoal, String ownLevel, String withOrWithout) {
	GridBagLayout gridBagLayout = new GridBagLayout();
	GridBagConstraints gridBagConstraints = new GridBagConstraints();

	dialog = new JDialog(new JFrame(), true);
	Container contentPane = dialog.getContentPane();
	contentPane.setLayout(gridBagLayout);

	JPanel panel = new JPanel(new FlowLayout(FlowLayout.LEFT,0,0));
	JLabel label = new JLabel("There is a conflict regarding ");
	panel.add(label);
	label = new JLabel(securityGoal);
	label.setForeground(Color.blue);
	panel.add(label);

	gridBagConstraints.insets = new Insets(10,10,0,10);
	gridBagConstraints.gridx = 0;
	gridBagConstraints.gridy = 0;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.gridwidth = 2;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.anchor = GridBagConstraints.NORTHWEST;
	gridBagLayout.setConstraints(panel, gridBagConstraints);
	contentPane.add(panel);

	panel = new JPanel(new FlowLayout(FlowLayout.LEFT,0,0));
	label = new JLabel("Your settings: ");
	panel.add(label);
	label = new JLabel(ownLevel);
	label.setForeground(Color.blue);
	panel.add(label);

	gridBagConstraints.insets = new Insets(0,10,0,10);
	gridBagConstraints.gridx = 0;
	gridBagConstraints.gridy = 1;
	gridBagConstraints.weightx = 0;
	gridBagConstraints.weighty = 0;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.gridwidth = 2;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.anchor = GridBagConstraints.NORTHWEST;
	gridBagLayout.setConstraints(panel, gridBagConstraints);
	contentPane.add(panel);

	panel = new JPanel(new FlowLayout(FlowLayout.LEFT,0,0));
	label = new JLabel("Do you like to give in and set up the connection ");
	panel.add(label);
	label = new JLabel(withOrWithout + securityGoal);
	label.setForeground(Color.red);
	panel.add(label);
	label = new JLabel("?");
	panel.add(label);

	gridBagConstraints.insets = new Insets(10,10,10,10);
	gridBagConstraints.gridx = 0;
	gridBagConstraints.gridy = 2;
	gridBagConstraints.weightx = 1;
	gridBagConstraints.weighty = 0;
	gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
	gridBagConstraints.gridwidth = 2;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.anchor = GridBagConstraints.NORTHWEST;
	gridBagLayout.setConstraints(panel, gridBagConstraints);
	contentPane.add(panel);

	okButton.addActionListener(this);
	gridBagConstraints.insets = new Insets(10,10,20,10);
	gridBagConstraints.gridx = 0;
	gridBagConstraints.gridy = 3;
	gridBagConstraints.weightx = 0.5;
	gridBagConstraints.weighty = 0;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.ipadx = 30;
	gridBagConstraints.ipady = 6;
	gridBagConstraints.anchor = GridBagConstraints.CENTER;
	gridBagLayout.setConstraints(okButton, gridBagConstraints);
	contentPane.add(okButton);

	cancelButton.addActionListener(this);
	gridBagConstraints.gridx = 1;
	gridBagConstraints.gridy = 3;
	gridBagConstraints.weightx = 0.5;
	gridBagConstraints.weighty = 0;
	gridBagConstraints.fill = GridBagConstraints.NONE;
	gridBagConstraints.gridwidth = 1;
	gridBagConstraints.gridheight = 1;
	gridBagConstraints.anchor = GridBagConstraints.CENTER;
	gridBagConstraints.ipadx = 30;
	gridBagConstraints.ipady = 6;
	gridBagLayout.setConstraints(cancelButton, gridBagConstraints);
	contentPane.add(cancelButton);
	dialog.pack();
    }

    public static boolean getAnswer(int securityGoal, ActionConfiguration ownConfig) {
	String ownLevel = null;
	String subjectString = null;
	switch (securityGoal) {
	case SSONETConstants.CONFIDENTIALITY:
	    subjectString = "Confidentliality";
	    break;
	case SSONETConstants.ANONYMITY:
	    subjectString = "Anonymity";
	    break;
	case SSONETConstants.ACCOUNTABILITY_SIGN:
	    subjectString = "Accountability";
	    break;
	case SSONETConstants.INTEGRITY:
	    subjectString = "Integrity";
	}
	ownLevel = ownConfig.toString(securityGoal);
	String withOrWithout = "with ";
	if(ownConfig.getSecurityGoalLevel(securityGoal) == 5)
	    withOrWithout = "without ";
	ConflictDialog conflictDialog = new ConflictDialog(subjectString, ownLevel, withOrWithout);
	conflictDialog.dialog.setTitle("Conflict regarding " + subjectString);
	conflictDialog.dialog.show();
	return conflictDialog.returnCode;
    }

    public void actionPerformed (ActionEvent event) {
	if (event.getSource() == okButton) {
	    returnCode = true;
	    dialog.dispose();
	}

	if (event.getSource() == cancelButton) {
	    returnCode = false;
	    dialog.dispose();
	}
    }
}
