/*
 * state/Pad.java
 *
 * SSONET Version 1.1
 * 24. April 2000
 * <mailto:ssonet@inf.tu-dresden.de>
 *
 */
package state;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
final public class Pad {
    final public static int MERCHANT = 3;
    final public static int SSONET = 1;
    final public static int PORT = 2005;

    private TextArea ta2 = new TextArea("", 200, 100, TextArea.SCROLLBARS_VERTICAL_ONLY);
    private TextArea ta4 = new TextArea("", 200, 100, TextArea.SCROLLBARS_VERTICAL_ONLY);
    private Label l2 = new Label("Negotiation");
    private Label l4 = new Label("Merchant");

    public Pad() {
	super();
	final class mouse implements MouseListener {
	    public void mouseClicked(MouseEvent e) {
	    }
	    public void mouseReleased(MouseEvent e) {
		if (e.getSource() == l2) {
		    if (e.isPopupTrigger()) {
			ta2.setText("");
		    }
		}
		else
		    if (e.getSource() == l4) {
                    if (e.isPopupTrigger()) {
                        ta4.setText("");
                    }
                }
	    }
	    public void mousePressed(MouseEvent e) {
	    }
	    public void mouseEntered(MouseEvent e) {
	    }
	    public void mouseExited(MouseEvent e) {
	    }
	}
	Frame f = new Frame("SSONET Status Window");
	f.setSize(600, 600);
	GridBagLayout g = new GridBagLayout();
	Panel p = new Panel(g);
	p.setBackground(Color.lightGray);
	GridBagConstraints c = new GridBagConstraints();

	c.gridx = 0;
	c.gridy = 0;
	c.weightx = 0;
	c.weighty = 0;
	c.fill = GridBagConstraints.NONE;
	c.gridwidth = 1;
	c.gridheight = 1;
	c.anchor = GridBagConstraints.CENTER;

	l2.addMouseListener(new mouse());
	c.gridx = 1;
	c.gridy = 0;
	c.weightx = 0;
	c.weighty = 0;
	c.fill = GridBagConstraints.NONE;
	c.gridwidth = 1;
	c.gridheight = 1;
	c.anchor = GridBagConstraints.CENTER;
	g.setConstraints(l2, c);

	ta2.setEditable(false);
	ta2.setBackground(Color.white);
	ta2.addMouseListener(new mouse());
	c.gridx = 1;
	c.gridy = 1;
	c.weightx = 0.5;
	c.weighty = 0.5;
	c.fill = GridBagConstraints.BOTH;
	c.gridwidth = 1;
	c.gridheight = 1;
	c.anchor = GridBagConstraints.CENTER;
	g.setConstraints(ta2, c);

	l4.addMouseListener(new mouse());
	c.gridx = 1;
	c.gridy = 2;
	c.weightx = 0;
	c.weighty = 0;
	c.fill = GridBagConstraints.NONE;
	c.gridwidth = 1;
	c.gridheight = 1;
	c.anchor = GridBagConstraints.CENTER;
	g.setConstraints(l4, c);

	ta4.setEditable(false);
	ta4.setBackground(Color.white);
	ta4.addMouseListener(new mouse());
	c.gridx = 1;
	c.gridy = 3;
	c.weightx = 0.5;
	c.weighty = 0.5;
	c.fill = GridBagConstraints.BOTH;
	c.gridwidth = 1;
	c.gridheight = 1;
	c.anchor = GridBagConstraints.CENTER;
	g.setConstraints(ta4, c);

	p.add(l2);
	p.add(ta2);
	p.add(l4);
	p.add(ta4);
	WindowListener l = new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {
		System.exit(0);
	    }
	};
	f.addWindowListener(l);
	f.add(p);
	f.show();
    }
    public void append(int ID, String string) {
	switch (ID) {
	case 1 :
	    ta2.append(string);
	    break;
	case 3 :
	    ta4.append(string);
	default :
	}
    }
    public static void main(String[] argv) {
	DatagramSocket socket = null;
	try {
	    Pad pad = new Pad();
	    socket = new DatagramSocket(Pad.PORT);
	    while (true) {
		DatagramPacket packet = new DatagramPacket(new byte[200], 200);
		socket.receive(packet);
		byte[] buff = packet.getData();
		pad.append((int) buff[0], new String(buff, 1, packet.getLength() - 1));
	    }
	} catch (Exception e) {
	    System.out.println("Error: " + e.getMessage() + "\n");
	    e.printStackTrace();
	    System.exit(0);
	}
    }
}
